/*
 * Created on Jun 30, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.graph;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.geom.RoundRectangle2D;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;

import vp.util.database.DBAccess;
import vp.visual.type.Type;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DataClass implements Map
{
	private String objectID;
	private PathwayGraph pg;
	private int classID;
	private String objectName;
	private String tableName;
	private String className;
	private int objectType;
	private final Map data;
	private Type storedType;

	public DataClass(String objectID, PathwayGraph pg)
	{
		this(objectID, pg, false);
	}

	public DataClass(String objectID, PathwayGraph pg, boolean lookup)
	{
		this.objectID = objectID;
		this.pg = pg;
		data = new Hashtable();

		if (lookup && (pg != null))
		{
			//initialize fields by accessing database
			ResultSet rs = null;
			boolean customType = false;
			Statement stmt = DBAccess.getStatement();
			String sql =
				"SELECT po.class_id, po.object_name, dc.table_name, dc.class_name, dc.is_edge"
					+ " FROM pathway_object po, drawing_classes dc "
					+ "WHERE po.object_id = '"
					+ objectID
					+ "' AND dc.class = po.class_id";
			try
			{
				rs = stmt.executeQuery(sql);
				while (rs.next())
				{
					classID = rs.getInt(1);
					objectName = rs.getString(2);
					tableName = rs.getString(3);
					className = rs.getString(4);
					objectType = rs.getInt(5);
				}
				String idName = "id";
				if (tableName.equals("HMR_ENZYME_CLONE"))
					idName = "enzyme_id";
				if (tableName.equals("HMR_GENE_CLONE"))
					idName = "gene_id";
				if (tableName.equals("HMR_REACTION"))
					idName = "reaction_id";
				sql =
					"SELECT * FROM "
						+ tableName
						+ " WHERE "
						+ idName
						+ " = '"
						+ objectID
						+ "'";
				rs = stmt.executeQuery(sql);
				int columnCount = rs.getMetaData().getColumnCount();
				while (rs.next())
				{
					for (int i = 0; i < columnCount; i++)
					{
						String colName = rs.getMetaData().getColumnName(i + 1);
						String value = rs.getString(i + 1);
						value = (value != null) ? value : "";
						put(colName, value);
					}
				}
				sql =
					"SELECT shape, outline_color, fill_color, font_family, font_size, font_style, font_color "
						+ "FROM pathway_object_appearance WHERE pathway_id = '"
						+ pg.getGraphDataClass().get("id")
						+ "' AND object_id = '"
						+ objectID
						+ "'";
				rs = stmt.executeQuery(sql);
				while (rs.next())
				{
					customType = true;
					String shape = rs.getString("shape");
					int outlineColor = rs.getInt("outline_color");
					int fillColor = rs.getInt("fill_color");
					String fontFamily = rs.getString("font_family");
					int fontStyle = rs.getInt("font_style");
					int fontSize = rs.getInt("font_size");
					int fontColor = rs.getInt("font_color");
					GeneralPath drawPath;
					if (shape.equals("Ellipse"))
						drawPath =
							new GeneralPath(new Ellipse2D.Double(5, 5, 10, 10));
					else if (shape.equals("Round Rectangle"))
						drawPath =
							new GeneralPath(
								new RoundRectangle2D.Double(
									5,
									5,
									10,
									10,
									2.5,
									2.5));
					else
						drawPath =
							new GeneralPath(
								new Rectangle2D.Double(5, 5, 10, 10));

					storedType =
						new Type(
							new Color(outlineColor),
							new Color(fillColor),
							new Color(fontColor),
							new Font(fontFamily, fontStyle, fontSize),
							drawPath,
							shape,
							"",
							"Obj");
				}
				if (!customType)
				{
					Type typeToUse =
						(pg.getLocalType(classID) != null)
							? pg.getLocalType(classID)
							: pg.getParent().getDefaultType(classID);
					storedType = typeToUse;
				}
			}
			catch (SQLException e)
			{
				e.printStackTrace();
			}
		}

		else
		{
			objectName = "blank";
			tableName = null;
			className = null;
			objectType = -1;
			//storedType = new InvisibleVertex();
		}

	}

	/* (non-Javadoc)
	 * @see java.util.Map#size()
	 */
	public int size()
	{
		return data.size();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#clear()
	 */
	public void clear()
	{
		data.clear();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#isEmpty()
	 */
	public boolean isEmpty()
	{
		return data.isEmpty();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#containsKey(java.lang.Object)
	 */
	public boolean containsKey(Object key)
	{
		return data.containsKey(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#containsValue(java.lang.Object)
	 */
	public boolean containsValue(Object value)
	{
		return data.containsValue(value);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#values()
	 */
	public Collection values()
	{
		return data.values();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#putAll(java.util.Map)
	 */
	public void putAll(Map t)
	{
		data.putAll(t);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#entrySet()
	 */
	public Set entrySet()
	{
		return data.entrySet();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#keySet()
	 */
	public Set keySet()
	{
		return data.keySet();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#get(java.lang.Object)
	 */
	public Object get(Object key)
	{
		return data.get(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#remove(java.lang.Object)
	 */
	public Object remove(Object key)
	{
		return data.remove(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
	 */
	public Object put(Object key, Object value)
	{
		return data.put(key, value);
	}

	/**
	 * @return
	 */
	public int getClassID()
	{
		return classID;
	}

	/**
	 * @return
	 */
	public String getClassName()
	{
		return className;
	}

	/**
	 * @return
	 */
	public Map getData()
	{
		return data;
	}

	/**
	 * @return
	 */
	public String getObjectID()
	{
		return objectID;
	}

	/**
	 * @return
	 */
	public String getObjectName()
	{
		return objectName;
	}

	/**
	 * @return
	 */
	public int getObjectType()
	{
		return objectType;
	}

	/**
	 * @return
	 */
	public Type getStoredType()
	{
		return storedType;
	}

	/**
	 * @return
	 */
	public String getTableName()
	{
		return tableName;
	}

	/**
	 * @param string
	 */
	public void setClassID(int classID)
	{
		this.classID = classID;
	}

	/**
	 * @param string
	 */
	public void setClassName(String string)
	{
		className = string;
	}

	/**
	 * @param string
	 */
	public void setObjectID(String string)
	{
		objectID = string;
	}

	/**
	 * @param string
	 */
	public void setObjectName(String string)
	{
		objectName = string;
	}

	/**
	 * @param i
	 */
	public void setObjectType(int i)
	{
		objectType = i;
	}

	/**
	 * @param string
	 */
	public void setTableName(String string)
	{
		tableName = string;
	}

	public boolean isBlank()
	{
		return pg == null;
	}
	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return objectName;
	}

	/**
	 * @param type
	 */
	public void setStoredType(Type type)
	{
		storedType = type;
	}

}
