/*
 * Created on Jul 12, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.graph;

import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Collection;
import java.util.Hashtable;
import java.util.Map;
import java.util.Set;

import vp.util.database.DBAccess;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GraphDataClass implements Map
{
	private String tableName;

	private String objectID;

	private final Map data;

	public static final String DEF_TABLE = "hmr_pathway";

	public GraphDataClass(String objectID)
	{
		this(objectID, DEF_TABLE, false);
	}

	public GraphDataClass(String objectID, String tableName, boolean lookup)
	{
		this.objectID = objectID;

		this.tableName = tableName;

		data = new Hashtable();

		if (lookup)
		{
			Statement stmt = DBAccess.getStatement();
			String sql =
				"SELECT * FROM " + tableName + " WHERE id = '" + objectID + "'";

			ResultSet rs;
			try
			{
				rs = stmt.executeQuery(sql);
				int columnCount = rs.getMetaData().getColumnCount();
				while (rs.next())
				{
					for (int i = 0; i < columnCount; i++)
					{
						String colName = rs.getMetaData().getColumnName(i + 1);
						String value = rs.getString(i + 1);
						put(colName, value);
					}
				}
			}

			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
	}

	/* (non-Javadoc)
	 * @see java.util.Map#size()
	 */
	public int size()
	{
		return data.size();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#clear()
	 */
	public void clear()
	{
		data.clear();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#isEmpty()
	 */
	public boolean isEmpty()
	{
		return data.isEmpty();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#containsKey(java.lang.Object)
	 */
	public boolean containsKey(Object key)
	{
		return data.containsKey(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#containsValue(java.lang.Object)
	 */
	public boolean containsValue(Object value)
	{
		return data.containsValue(value);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#values()
	 */
	public Collection values()
	{
		return data.values();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#putAll(java.util.Map)
	 */
	public void putAll(Map t)
	{
		data.putAll(t);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#entrySet()
	 */
	public Set entrySet()
	{
		return data.entrySet();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#keySet()
	 */
	public Set keySet()
	{
		return data.keySet();
	}

	/* (non-Javadoc)
	 * @see java.util.Map#get(java.lang.Object)
	 */
	public Object get(Object key)
	{
		return data.get(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#remove(java.lang.Object)
	 */
	public Object remove(Object key)
	{
		return data.remove(key);
	}

	/* (non-Javadoc)
	 * @see java.util.Map#put(java.lang.Object, java.lang.Object)
	 */
	public Object put(Object key, Object value)
	{
		return data.put(key, value);
	}
	/**
	 * @return
	 */
	public String getObjectID()
	{
		return objectID;
	}

	/**
	 * @return
	 */
	public String getTableName()
	{
		return tableName;
	}

	/**
	 * @param string
	 */
	public void setObjectID(String string)
	{
		objectID = string;
	}

	/**
	 * @param string
	 */
	public void setTableName(String string)
	{
		tableName = string;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	public String toString()
	{
		return (String)get("Name");
	}

}
