package vp.graph;

/** 
* The interface for structural elements that have labels.  Specifically, this is 
* vertices and decorations.  It is implemented with <code>LabeledElementImp</code>.
*
* @see edu.yale.graph.LabeledElementImp
*/

public interface LabeledElement extends GraphElement
{
	/**
	* Returns the element's label.
	*
	* @see #setLabel(String label)
	*/
	String getLabel();

	/**
	* Returns true if a label has been specified.
	*/
	boolean hasLabel();

	/**
	* Sets the element's label to the specified string.
	*
	* @see #getLabel()
	*/
	void setLabel(String label);
}
