package vp.graph;

/** 
* The common interface for all types of vertices.
* The vertex is one of the basic building blocks this program uses to conceptualize pathway graphs.
* Typically, a vertex represents an end point on the graph and represents a resulting compound or another pathway.
* With the exception of the <code>DummyVertex</code> it moves independently of the other elements in the graph.
* <code>Vertex</code> can be implemented generally with <code>VertexImp</code> or more specifically using <code>
* PWVertex</code>.   Its visual cognate is <code>VisualVertex</code>.
*
* @see edu.yale.graph.VertexImp
* @see edu.yale.graph.PWVertex
* @see edu.yale.graph.Compound
* @see edu.yale.graph.visual.VisualVertex
*/

public interface Vertex extends GraphElement
{
    Graph getGraph();
    int getID();
    void setID(int id);
    Object getObject();
    void setObject(Object obj);
}