/*
 * Created on Mar 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.components;

import java.awt.Dimension;
import java.util.StringTokenizer;

import javax.swing.JTextArea;
import javax.swing.SwingUtilities;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.LineBorder;
import javax.swing.text.BadLocationException;
import javax.swing.text.Utilities;

import vp.gui.*;
import vp.main.MainFrame;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AnnotationArea extends JTextArea
{
	private MainFrame mainFrame;
	private static AnnotationArea thisArea;
	private int visLines, rowHeight;
    
    public AnnotationArea(MainFrame parent)
    {
        this(parent, "");
    }

	public AnnotationArea(MainFrame parent, String annotation)
	{
		this.mainFrame = parent;
		thisArea = this;
		visLines = 4;
		setBackground(parent.getDisplayPanel().getBackground());
		setFont(VPSettings.R_FONT);
		setLineWrap(true);
		setWrapStyleWord(true);
		setEditable(false);
		setText(annotation);
		rowHeight = getFontMetrics(VPSettings.R_FONT).getHeight() + 3;
		setPreferredSize(new Dimension(275, rowHeight * visLines));
	}

	public void setAnnotate()
	{
		setBackground(VPSettings.Colors.SKY_BLUE);
		setBorder(
			new CompoundBorder(
				new LineBorder(VPSettings.Colors.D_BLUE),
				new EmptyBorder(5, 5, 5, 5)));
		setEditable(true);
	}

	public void setSave()
	{
		setBackground(mainFrame.getDisplayPanel().getBackground());
		setBorder(null);
		setEditable(false);
	}

	public void noteChange()
	{

		SwingUtilities.invokeLater(new Runnable()
		{
			public void run()
			{
				String test = getWrappedText();
				StringTokenizer stkr =
					new StringTokenizer(test, VPSettings.NEW_LINE);
				int lines = stkr.countTokens();
				thisArea.checkLines(lines);
			}
		});
	}

	/**
	 * @param lines
	 */
	protected void checkLines(int lines)
	{
		if (lines >= visLines)
		{
			visLines = lines;
			setPreferredSize(new Dimension(275, rowHeight * visLines));
		}
	}

	private String getWrappedText()
	{
		int len = getDocument().getLength();
		int offset = 0;
		StringBuffer buf = new StringBuffer((int) (len * 1.10));

		while (offset < len)
		{
			int end = 0;
			try
			{
				end = Utilities.getRowEnd(this, offset);
				if (end < 0)
				{
					break;
				}
				end = Math.min(end + 1, len);
				String line;
				line = getDocument().getText(offset, end - offset);
				line =
					line.replaceAll(
						VPSettings.NEW_LINE,
						" " + VPSettings.NEW_LINE);

				buf.append(line);
				if (!line.endsWith(VPSettings.NEW_LINE))
				{
					buf.append(VPSettings.NEW_LINE);
				}
			}

			catch (BadLocationException e1)
			{
				e1.printStackTrace();
				break;
			}
			offset = end;

		}
		return buf.toString();
	}
	/**
	 * @return
	 */
	public MainFrame getMainFrame()
	{
		return mainFrame;
	}

	/**
	 * @param frame
	 */
	public void setMainFrame(MainFrame frame)
	{
		mainFrame = frame;
	}

	/**
	 * @return
	 */
	public int getRowHeight()
	{
		return rowHeight;
	}

	/**
	 * @return
	 */
	public int getVisLines()
	{
		return visLines;
	}

	/**
	 * @param i
	 */
	public void setRowHeight(int height)
	{
		rowHeight = height;
	}

	/**
	 * @param i
	 */
	public void setVisLines(int height)
	{
		visLines = height;
	}

}
