package vp.gui.components;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.event.ActionListener;
import java.awt.image.BufferedImage;
import javax.swing.ImageIcon;
import javax.swing.JButton;

public class ColorButton extends JButton
{

	public ColorButton(
		Color color,
		String command,
		ActionListener listener)
	{
		setPreferredSize(new Dimension(40, 20));
		BufferedImage bImage =
			new BufferedImage(40, 20, BufferedImage.TYPE_INT_RGB);
		Graphics2D big = bImage.createGraphics();
		big.setColor(color);
		big.fillRect(0, 0, 40, 20);
		setIcon(new ImageIcon(bImage));
		setActionCommand(command);
		addActionListener(listener);
	}

	public void changeColor(Color color)
	{
		BufferedImage bImage =
			new BufferedImage(40, 20, BufferedImage.TYPE_INT_RGB);
		Graphics2D big = bImage.createGraphics();
		big.setColor(color);
		big.fillRect(0, 0, 40, 20);
		setIcon(new ImageIcon(bImage));
	}
}
