/*
 * Created on Mar 25, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.RenderingHints;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.Ellipse2D;
import javax.swing.JLabel;
import javax.swing.JPopupMenu;
import javax.swing.border.EmptyBorder;

import vp.gui.VPSettings;
import vp.main.MainFrame;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ExpandableVPRLabel extends JLabel
{
    private MainFrame parent;
    private ExpandableVPRLabel thisLabel;
    private Listener listener;
    private JPopupMenu pop;
    private String label;
    private VPRLabel popImage;
    private Ellipse2D.Double zoomCircle;
    private int maxWidth, width, height;
    private boolean expand;

    public ExpandableVPRLabel(MainFrame parent, String label)
    {
        this(parent, label, 22);
    }

    /**
     * @param label
     * @param i
     */
    public ExpandableVPRLabel(MainFrame parent, String label, int maxWidth)
    {
        this.parent = parent;
        this.label = label;
        this.maxWidth = maxWidth;
        thisLabel = this;
        listener = new Listener();
        setFont(VPSettings.R_FONT);
        setBorder(new EmptyBorder(5, 5, 5, 5));
        height = getPreferredSize().height + 2;
        resetText(label);
    }

    public void resetText(String label)
    {
        this.label = label;
        String showString = label.replaceAll("<br>", "");
        showString = showString.replaceAll("<html>", "");

        if (showString.length() < maxWidth)
        {
            setText(showString);
            expand = false;
        }
        else
        {

            String cutOffText = showString.substring(0, maxWidth);
            cutOffText = cutOffText.concat("...");

            width = getFontMetrics(getFont()).stringWidth(cutOffText) + 20;
            
            setPreferredSize(new Dimension(width, height));
            setText(cutOffText);
            expand = true;

        }
    }

    public void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        if (expand)
        {
            Graphics2D g2 = (Graphics2D)g;
            g2.setRenderingHint(
                RenderingHints.KEY_ANTIALIASING,
                RenderingHints.VALUE_ANTIALIAS_ON);
            g2.setColor(Color.BLACK);
            g2.drawLine(
                width - 10,
                (height / 2) - 1,
                width - 2,
                (height / 2) - 1);
            g2.drawLine(
                width - 6,
                (height / 2) - 6,
                width - 6,
                (height / 2) + 3);
            zoomCircle =
                new Ellipse2D.Double(width - 11, (height / 2) - 6, 10, 10);
            g2.draw(zoomCircle);
            VPPanel p = new VPPanel();
            popImage = new VPRLabel(label);
            p.add(popImage);
            pop = new JPopupMenu();
            pop.add(p);

            addMouseMotionListener(listener);
        }
    }

    /**
         * @author Matt
         *
         * To change the template for this generated type comment go to
         * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
         */
    public class Listener implements MouseListener, MouseMotionListener
    {

        /* (non-Javadoc)
         * @see java.awt.event.MouseListener#mouseClicked(java.awt.event.MouseEvent)
         */
        public void mouseClicked(MouseEvent e)
        {}

        /* (non-Javadoc)
         * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
         */
        public void mouseEntered(MouseEvent e)
        {}

        /* (non-Javadoc)
         * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
         */
        public void mouseExited(MouseEvent e)
        {
            pop.setVisible(false);
        }

        /* (non-Javadoc)
         * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
         */
        public void mousePressed(MouseEvent e)
        {}

        /* (non-Javadoc)
         * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
         */
        public void mouseReleased(MouseEvent e)
        {}

        /* (non-Javadoc)
         * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
         */
        public void mouseDragged(MouseEvent e)
        {}

        /* (non-Javadoc)
         * @see java.awt.event.MouseMotionListener#mouseMoved(java.awt.event.MouseEvent)
         */
        public void mouseMoved(MouseEvent e)
        {
            Point point = new Point(e.getX() - 5, e.getY() - 5);
            if (zoomCircle.getBounds().contains(point))
            {
                Point screenLoc =
                    ((Component)e.getSource()).getLocationOnScreen();
                pop.setLocation(screenLoc.x, screenLoc.y);
                pop.setVisible(true);
                pop.addMouseListener(this);
            }
            else
                pop.setVisible(false);

        }
    }
}
