/*
 * Created on May 3, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.components;

import javax.swing.JTextPane;
import javax.swing.text.BadLocationException;
import javax.swing.text.Style;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;

import vp.graph.Experiment;
import vp.gui.VPSettings;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ExperimentDetailPanel extends JTextPane
{

	public ExperimentDetailPanel(Experiment exp)
	{
		String title = (exp != null) ? exp.getName() : "No experiment selected";

		String expDescr = (exp != null) ? exp.getDescription() : "";
		String expType =
			(exp != null) ? "Experiment type:  " + exp.getIdType() : "";
		String expUpload =
			(exp != null) ? "Uploaded on " + exp.getUploadDate() : "";

		StyledDocument doc = getStyledDocument();
		addStyles(doc);

		try
		{
			doc.insertString(0, title + "\n\n", doc.getStyle("bold"));
		}
		catch (BadLocationException e)
		{
			e.printStackTrace();
		}
		try
		{
			doc.insertString(
				doc.getLength(),
				expDescr + "\n\n",
				doc.getStyle("reg"));
		}
		catch (BadLocationException e1)
		{
			e1.printStackTrace();
		}
		try
		{
			doc.insertString(
				doc.getLength(),
				expType + "\n\n",
				doc.getStyle("reg"));
		}
		catch (BadLocationException e2)
		{
			e2.printStackTrace();
		}
		try
		{
			doc.insertString(
				doc.getLength(),
				expUpload,
				doc.getStyle("italic"));
		}
		catch (BadLocationException e3)
		{
			e3.printStackTrace();
		}

		setCaretPosition(0);

	}
	/**
	 * @param doc
	 */
	private void addStyles(StyledDocument doc)
	{
		Style def =
			StyleContext.getDefaultStyleContext().getStyle(
				StyleContext.DEFAULT_STYLE);
		Style style = doc.addStyle("reg", def);
		StyleConstants.setFontFamily(style, VPSettings.R_FONT.getFamily());
		StyleConstants.setBold(style, VPSettings.R_FONT.isBold());
		StyleConstants.setFontSize(style, VPSettings.R_FONT.getSize());
		style = doc.addStyle("bold", def);
		StyleConstants.setFontFamily(style, VPSettings.R_FONT.getFamily());
		StyleConstants.setBold(style, VPSettings.B_FONT.isBold());
		StyleConstants.setFontSize(style, VPSettings.B_FONT.getSize());
		style = doc.addStyle("italic", def);
		StyleConstants.setFontFamily(style, VPSettings.R_FONT.getFamily());
		StyleConstants.setBold(style, VPSettings.R_FONT.isBold());
		StyleConstants.setFontSize(style, VPSettings.R_FONT.getSize());
		StyleConstants.setItalic(style, true);

	}

}
