/*
 * Created on May 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.components;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.image.BufferedImage;

import javax.swing.ImageIcon;
import javax.swing.JLabel;

import vp.graph.VPGradient;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GradientLabel extends JLabel
{
	private static BufferedImage bImage;

	private Dimension size;

	private Color midColor;

	private Color maxColor;

	private Color minColor;

	private static final Dimension DEF_DIM = new Dimension(30, 150);

	public GradientLabel(Color minColor, Color maxColor)
	{
		this(minColor, maxColor, null, DEF_DIM);
	}

	public GradientLabel(Color minColor, Color maxColor, Dimension size)
	{
		this(minColor, maxColor, null, size);
	}

	public GradientLabel(Color minColor, Color maxColor, Color midColor)
	{
		this(minColor, maxColor, midColor, DEF_DIM);
	}

	public GradientLabel(
		Color minColor,
		Color maxColor,
		Color midColor,
		Dimension size)
	{
		this.minColor = minColor;
		this.maxColor = maxColor;
		this.midColor = midColor;
		this.size = size;

		bImage = createBufferedImage();
		setIcon(new ImageIcon(bImage));
	}

	public void redraw(Color minColor, Color maxColor)
	{
		redraw(minColor, maxColor, null);
	}

	public void redraw(Color minColor, Color maxColor, Color midColor)
	{
		this.minColor = minColor;
		this.maxColor = maxColor;
		this.midColor = midColor;

		bImage = createBufferedImage();
		setIcon(new ImageIcon(bImage));
	}

	/**
	 * @return
	 */
	private BufferedImage createBufferedImage()
	{
		BufferedImage rImage = VPGradient.getGradientImage(minColor, maxColor, midColor, size);
		return rImage;
	}

	

	public Color getColorAtValue(double percent)
	{
		int vHeight = (int) ((size.height - 1) * percent);
		return new Color(bImage.getRGB(0, vHeight));
	}
	/**
	 * @return
	 */
	public Color getMaxColor()
	{
		return maxColor;
	}

	/**
	 * @return
	 */
	public Color getMidColor()
	{
		return midColor;
	}

	/**
	 * @return
	 */
	public Color getMinColor()
	{
		return minColor;
	}

	/**
	 * @param color
	 */
	public void setMaxColor(Color color)
	{
		maxColor = color;
	}

	/**
	 * @param color
	 */
	public void setMidColor(Color color)
	{
		midColor = color;
	}

	/**
	 * @param color
	 */
	public void setMinColor(Color color)
	{
		minColor = color;
	}

	/**
	 * @return
	 */
	public Dimension getSize()
	{
		return size;
	}

	/**
	 * @param dimension
	 */
	public void setSize(Dimension dimension)
	{
		size = dimension;
	}

}
