package vp.gui.components;

import java.awt.Insets;
import java.awt.event.ActionListener;
import javax.swing.JTextField;
import javax.swing.border.EtchedBorder;

import vp.gui.VPSettings;

public class VPTextField extends JTextField
{
	public VPTextField()
	{
		this("", null, null);
	}

	public VPTextField(String text)
	{
		this(text, null, null);
	}

	public VPTextField(String actionCommand, ActionListener listener)
	{
		this("", actionCommand, listener);
	}

	public VPTextField(
		String text,
		String actionCommand,
		ActionListener listener)
	{
		super(text);
		setBorder(new EtchedBorder());
		setMargin(new Insets(0, 5, 0, 5));
		setFont(VPSettings.R_FONT);
		setActionCommand(actionCommand);
		addActionListener(listener);
	}
}
