/*
 * Created on May 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.dialogs;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.RenderingHints;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.swing.ImageIcon;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JSeparator;
import javax.swing.JSlider;
import javax.swing.JTextField;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import vp.graph.PathwayElement;
import vp.graph.PathwayGraph;
import vp.graph.PathwayVertex;
import vp.graph.VPGradient;
import vp.gui.VPSettings;
import vp.gui.components.ColorButton;
import vp.gui.components.DialogFactory;
import vp.gui.components.DialogHeader;
import vp.gui.components.GradientLabel;
import vp.gui.components.PreviewPanel;
import vp.gui.components.VPBLabel;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.gui.components.VPRLabel;
import vp.gui.components.VPTextField;
import vp.main.MainFrame;
import vp.util.ActionCenter;
import vp.util.GraphUtilities;
import vp.util.IconFactory;
import vp.util.TypeChangeEvent;
import vp.util.TypeChangeListener;
import vp.visual.type.Type;

/**
 * @author Matt Holford
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
 * Comments
 */
public class EditGradientDialog extends VPPanel
{
    /**
     * @author Matt Holford
     * 
     * To change the template for this generated type comment go to
     * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
     * Comments
     */
    private class SliderLabel extends JLabel
    {

        /**
         * @param string
         */
        public SliderLabel(String string)
        {
            super(string, JLabel.CENTER);
            setFont(VPSettings.SR_FONT);

        }

        protected void paintComponent(Graphics g)
        {
            Graphics2D g2 = (Graphics2D) g;
            g2.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING,
                RenderingHints.VALUE_TEXT_ANTIALIAS_ON);

            super.paintComponent(g);
        }
    }

    private class ValueLabel extends JLabel
    {
        public ValueLabel(ArrayList values)
        {
            super();
            setIcon(new ImageIcon(getImage(values)));
        }

        public void redraw(ArrayList values)
        {
            setIcon(new ImageIcon(getImage(values)));
        }

        private BufferedImage getImage(ArrayList values)
        {
            BufferedImage rImage = new BufferedImage(10, gradLabel
                .getSize().height, BufferedImage.TYPE_INT_ARGB);
            Graphics2D rig = rImage.createGraphics();
            rig.setColor(VPSettings.Colors.CLEAR);
            rig.fillRect(0, 0, rImage.getWidth(), rImage.getHeight());
            rig.setColor(VPSettings.Colors.M_BLUE);
            for (int i = 0; i < values.size(); i++)
            {
                double percent = 1 - ((((Double) values.get(i))
                    .doubleValue() - min) / (max - min));

                int vHeight = (int) ((gradLabel.getSize().height - 3) * percent);
                rig.drawRect(0, vHeight, 9, 2);

            }

            return rImage;
        }
    }

    /**
     * @author Matt Holford
     * 
     * To change the template for this generated type comment go to
     * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
     * Comments
     */

    private ArrayList expValues;

    private ValueLabel vp;

    private EditGradientDialog thisDialog;

    private ColorButton nullColorButton;

    private Color nullColor;

    private JComponent referrer;

    private JSlider gradValue;

    private VPBLabel slideValue;

    private ColorButton maxColorButton;

    private ColorButton minColorButton;

    private Color maxColor;

    private Color minColor;

    private VPTextField maxField;

    private VPTextField minField;

    private PreviewPanel pp;

    private GradientLabel gradLabel;

    private double max;

    private double min;

    private Map expData;

    private PathwayGraph pGraph;

    private MainFrame parent;

    private Listener listener;

    private List typeChangeListeners;

    private PathwayElement currentElement;

    public EditGradientDialog(MainFrame parent, Map expData,
        JComponent referrer)
    {
        this.parent = parent;
        this.expData = expData;
        this.referrer = referrer;
        pGraph = parent.getPathwayGraph();
        thisDialog = this;
        listener = new Listener();
        minColor = Color.YELLOW;
        maxColor = Color.RED;
        nullColor = Color.GRAY;
        typeChangeListeners = new ArrayList();
        ArrayList preExpValues = new ArrayList(((HashMap) expData).values());
        
        expValues = new ArrayList();

        for (int i = 0; i < preExpValues.size(); i++)
        {
            if (preExpValues.get(i) instanceof HashMap)
            {
                HashMap valueMap = (HashMap) preExpValues.get(i);
                Iterator iter = valueMap.values().iterator();
                while (iter.hasNext())
                {
                    Object o = iter.next();
                    try
                    {
                        Double dble = new Double(String.valueOf(o));
                        expValues.add(dble);
                    }
                    catch (NumberFormatException nfe)
                    {
                        continue;
                    }
                }
            }
            else
            {
                try
                {
                    Double dble = new Double(String.valueOf(preExpValues.get(i)));
                    expValues.add(dble);
                }
                catch (NumberFormatException nfe)
                {
                    continue;
                }
               
            }
        }
        Collections.sort(expValues);

        if (expValues.size() <= 0)
        {
            parent.addToEditPanel(referrer);
            String title = "Error";
            String header = "No values found!";
            String body = "There are no data values in this  \n"
                + "experiment for the current pathway.\n"
                + "Please select a different \n"
                + "pathway or experiment";
            DialogFactory.createDialog(parent, IconFactory
                .getErrorIcon(), title, header, body,
                DialogFactory.OK_ONLY);
            return;
        }
        min = ((Double) expValues.get(0)).doubleValue();
        max = ((Double) expValues.get(expValues.size() - 1))
            .doubleValue();

        setLayout(new GridBagLayout());
        setBackground(VPSettings.Colors.SIDE_PANEL);
        GridBagConstraints superc = new GridBagConstraints();
        superc.anchor = GridBagConstraints.WEST;
        superc.insets = new Insets(6, 5, 5, 8);
        VPPanel p = new DialogHeader(IconFactory.getVPIcon(),
            "Define the gradient to use");
        superc.gridwidth = 3;
        add(p, superc);

        superc.gridy = 1;
        superc.fill = GridBagConstraints.BOTH;
        superc.insets = new Insets(5, 5, 5, 5);
        add(new JSeparator(JSeparator.HORIZONTAL), superc);

        superc.gridy = 2;
        superc.gridwidth = 1;
        superc.anchor = GridBagConstraints.WEST;

        VPPanel leftPanel = new VPPanel();
        leftPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
        leftPanel.setLayout(new GridBagLayout());
        GridBagConstraints leftc = new GridBagConstraints();
        leftc.anchor = GridBagConstraints.WEST;
        leftc.fill = GridBagConstraints.BOTH;
        leftc.insets = new Insets(5, 5, 5, 5);

        gradLabel = new GradientLabel(minColor, maxColor);

        gradValue = new JSlider(JSlider.VERTICAL, (int) min,
            (int) max, (int) min + (int) ((max - min) / 2));
        gradValue.addChangeListener(listener);
        gradValue.setBackground(VPSettings.Colors.SIDE_PANEL);
        gradValue.setPreferredSize(new Dimension(100, 160));
        DecimalFormat nf = (DecimalFormat) NumberFormat.getInstance();
        nf.setMaximumFractionDigits(3);
        nf.setNegativePrefix("-");
        Hashtable labels = new Hashtable(4);
        for (double d = (double) min; d <= (double) max; d += (double) (max - min) / 4)
        {

            labels.put(new Integer((int) (d)), new SliderLabel(""
                + nf.format(d)));
        }
        gradValue.setLabelTable(labels);
        gradValue.setPaintLabels(true);
        gradValue.setMinorTickSpacing((int) (max - min) / 12);
        gradValue.setPaintTicks(true);

        leftPanel.add(gradValue, leftc);

        leftc.gridx = 1;
        vp = new ValueLabel(expValues);
        leftPanel.add(vp, leftc);

        leftc.gridx = 2;
        leftPanel.add(gradLabel, leftc);

        leftc.gridy = 1;
        leftc.gridx = 0;
        leftc.gridwidth = 3;
        leftc.anchor = GridBagConstraints.CENTER;
        leftc.fill = GridBagConstraints.NONE;
        currentElement = extractVertex();
        pp = new PreviewPanel(parent, currentElement, new Dimension(
            75, 40));
        typeChangeListeners.add(pp);
        leftPanel.add(pp, leftc);

        leftc.gridy = 2;
        leftc.fill = GridBagConstraints.BOTH;
        leftPanel.add(new JSeparator(JSeparator.HORIZONTAL), leftc);

        leftc.gridy = 3;
        leftc.gridwidth = 1;
        leftPanel.add(new VPButton("Save Type",
            ActionCenter.LOAD_GRADIENT, listener), leftc);
        leftc.gridx = 1;
        leftc.gridwidth = 2;
        leftPanel.add(new VPButton("Load",
            ActionCenter.SAVE_GRADIENT, listener), leftc);

        add(leftPanel, superc);

        superc.gridx = 1;
        add(new JSeparator(JSeparator.VERTICAL), superc);

        superc.gridx = 2;
        superc.insets = new Insets(5, 10, 5, 5);

        VPPanel rightPanel = new VPPanel();
        rightPanel.setLayout(new GridBagLayout());
        rightPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
        GridBagConstraints rightc = new GridBagConstraints();
        rightc.anchor = GridBagConstraints.WEST;
        rightc.gridwidth = 4;
        Insets reg = new Insets(0, 0, 0, 0);
        Insets indent = new Insets(0, 20, 0, 5);

        rightc.insets = reg;
        rightPanel.add(new VPBLabel("Colors"), rightc);

        rightc.gridy = 1;
        rightc.gridwidth = 2;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("Min: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        minColorButton = new ColorButton(minColor,
            ActionCenter.EDIT_MIN_COLOR, listener);
        rightPanel.add(minColorButton, rightc);

        rightc.gridy = 2;
        rightc.gridx = 0;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("Max: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        maxColorButton = new ColorButton(maxColor,
            ActionCenter.EDIT_MAX_COLOR, listener);
        rightPanel.add(maxColorButton, rightc);

        rightc.gridy = 3;
        rightc.gridx = 0;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("Mid: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        rightPanel.add(new VPRLabel("N/A"), rightc);

        rightc.gridy = 4;
        rightc.gridx = 0;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("No Value: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        nullColorButton = new ColorButton(nullColor,
            ActionCenter.EDIT_NULL_COLOR, listener);
        rightPanel.add(nullColorButton, rightc);

        rightc.gridy = 5;
        rightc.gridx = 0;
        rightc.gridwidth = 4;
        rightPanel.add(new VPBLabel("Values"), rightc);

        rightc.gridy = 6;
        rightc.gridwidth = 2;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("Min: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        rightc.fill = GridBagConstraints.HORIZONTAL;
        minField = new VPTextField(String.valueOf(nf.format(min)),
            ActionCenter.SET_GRADIENT_MIN, listener);
        minField.setHorizontalAlignment(JTextField.RIGHT);
        rightPanel.add(minField, rightc);

        rightc.gridy = 7;
        rightc.gridx = 0;
        rightc.insets = indent;
        rightPanel.add(new VPRLabel("Max: "), rightc);
        rightc.gridx = 2;
        rightc.insets = reg;
        maxField = new VPTextField(String.valueOf(nf.format(max)),
            ActionCenter.SET_GRADIENT_MAX, listener);
        maxField.setHorizontalAlignment(JTextField.RIGHT);
        rightPanel.add(maxField, rightc);

        rightc.gridy = 8;
        rightc.gridx = 0;
        rightc.gridwidth = 4;
        rightc.insets = new Insets(5, 5, 5, 5);
        rightc.fill = GridBagConstraints.BOTH;
        rightPanel.add(new JSeparator(JSeparator.HORIZONTAL), rightc);

        rightc.gridy = 9;
        rightc.gridwidth = 1;
        rightPanel.add(new VPButton("OK", ActionCenter.OK, listener),
            rightc);
        rightc.gridx = 1;
        rightc.gridwidth = 3;
        rightPanel.add(new VPButton("Cancel", ActionCenter.CANCEL,
            listener), rightc);

        add(rightPanel, superc);
    }

    public void fireTypeChange(TypeChangeEvent event)
    {
        for (int i = 0; i < typeChangeListeners.size(); i++)
        {
            ((TypeChangeListener) typeChangeListeners.get(i))
                .typeChanged(event);
        }
    }

    private void update()
    {
        currentElement = extractVertex();
        fireTypeChange(new TypeChangeEvent(thisDialog, pGraph,
            currentElement));
    }

    private PathwayVertex extractVertex()
    {
        double percent = 1 - (gradValue.getValue() - min)
            / (max - min);
        Color c = gradLabel.getColorAtValue(percent);
        Type newType = new Type(Color.BLACK, c, Color.BLACK,
            VPSettings.R_FONT, new GeneralPath(
                new Rectangle2D.Double(5, 5, 10, 10)), "Rectangle",
            "temp", "temp");
        PathwayVertex tempVert = new PathwayVertex(null, -1,
            GraphUtilities.HEADLESS_VERTEX, newType, 0, 0);
        tempVert.setLabel(String.valueOf(gradValue.getValue()));
        return tempVert;
    }

    private class Listener implements ActionListener, ChangeListener
    {

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent e)
        {
            String command = e.getActionCommand();
            if (command.equals(ActionCenter.OK))
            {
                if (referrer instanceof SelectExperimentDialog)
                    ((SelectExperimentDialog) referrer)
                        .setGradient(new VPGradient(minColor,
                            maxColor, nullColor, max, min));
                parent.addToEditPanel(referrer);
            }
            else if (command.equals(ActionCenter.CANCEL))
            {
                parent.addToEditPanel(referrer);
            }

            else if (command.equals(ActionCenter.EDIT_MIN_COLOR))
            {
                minColor = VPSettings.getVPColorChooser(thisDialog,
                    "Select Minimum Gradient Color", minColor);
                minColorButton.changeColor(minColor);
                gradLabel.redraw(minColor, maxColor);
                update();
            }

            else if (command.equals(ActionCenter.EDIT_MAX_COLOR))
            {
                maxColor = VPSettings.getVPColorChooser(thisDialog,
                    "Select Maximum Gradient Color", maxColor);
                maxColorButton.changeColor(maxColor);
                gradLabel.redraw(minColor, maxColor);
                update();
            }

            else if (command.equals(ActionCenter.EDIT_NULL_COLOR))
            {
                nullColor = VPSettings.getVPColorChooser(thisDialog,
                    "Select No Value Color", nullColor);
                nullColorButton.changeColor(nullColor);
            }

            else if (command.equals(ActionCenter.SET_GRADIENT_MAX))
            {
                max = Double.valueOf(maxField.getText())
                    .doubleValue();
                gradValue.setMaximum((int) max);
                Hashtable labels = new Hashtable(4);
                for (int d = (int) min; d <= (int) max; d += (int) (max - min) / 4)
                    labels.put(new Integer(d),
                        new SliderLabel("" + d));
                gradValue.setLabelTable(labels);
                gradValue.setPaintLabels(true);
                gradValue.setMinorTickSpacing((int) (max - min) / 12);
                gradValue.setPaintTicks(true);
                vp.redraw(expValues);
            }

            else if (command.equals(ActionCenter.SET_GRADIENT_MIN))
            {
                min = Double.valueOf(minField.getText())
                    .doubleValue();
                gradValue.setMinimum((int) min);
                Hashtable labels = new Hashtable(4);
                for (int d = (int) min; d <= (int) max; d += (int) (max - min) / 4)
                    labels.put(new Integer(d),
                        new SliderLabel("" + d));
                gradValue.setLabelTable(labels);
                gradValue.setPaintLabels(true);
                gradValue.setMinorTickSpacing((int) (max - min) / 12);
                gradValue.setPaintTicks(true);
                vp.redraw(expValues);
            }

        }

        /*
         * (non-Javadoc)
         * 
         * @see javax.swing.event.ChangeListener#stateChanged(javax.swing.event.ChangeEvent)
         */
        public void stateChanged(ChangeEvent e)
        {
            if (e.getSource() == gradValue)
            {
                update();
            }
        }
    }

}
