/*
 * Created on Jun 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JViewport;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import vp.graph.DataClass;
import vp.graph.PathwayGraph;
import vp.gui.VPSettings;
import vp.gui.components.AnnotationArea;
import vp.gui.components.VPBLabel;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.gui.components.VPRLabel;
import vp.main.MainFrame;
import vp.util.ActionCenter;
import vp.util.BrowserLauncher;
import vp.util.StringBreaker;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class GeneDisplayPanel extends VPPanel
{
	private VPButton annotateButton;
	private JViewport jv;
	private AnnotationArea annotationArea;
	private VPBLabel compoundLabel;
	/**
	 * @author Matt Holford
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private MainFrame parent;
	private PathwayGraph pGraph;

	private GeneDisplayPanel thisPanel;

	private DataClass gene;

	public GeneDisplayPanel(MainFrame parent, DataClass gene)
	{
		this.parent = parent;
		this.gene = gene;
		thisPanel = this;
		pGraph = parent.getPathwayGraph();
		Listener listener = new Listener();
		setLayout(new GridBagLayout());
		setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints superc = new GridBagConstraints();
		superc.anchor = GridBagConstraints.WEST;
		superc.fill = GridBagConstraints.BOTH;
		superc.insets = new Insets(5, 5, 5, 5);
		superc.weighty = 2.0;

		VPPanel topPanel = new VPPanel();
		topPanel.setLayout(new GridBagLayout());
		topPanel.setBackground(VPSettings.Colors.SIDE_PANEL);

		GridBagConstraints topc = new GridBagConstraints();
		Insets regular = new Insets(0, 10, 0, 5);
		Insets indent = new Insets(0, 50, 5, 5);
		topc.anchor = GridBagConstraints.WEST;
		topc.fill = GridBagConstraints.BOTH;
		topc.weightx = 2;
		topc.insets = new Insets(10, 10, 0, 5);
		compoundLabel = new VPBLabel("Gene:");
		topPanel.add(compoundLabel, topc);
		topc.gridy = 1;
		topc.insets = indent;
		topc.weighty = 0;
		String geneName =
			(gene != null)
				? StringBreaker.breakStringForLabel((String)gene.get("Name"), 50)
				: "N/A";
		topPanel.add(new VPRLabel(geneName), topc);

		topc.gridy = 2;
		topc.insets = regular;
		topPanel.add(new VPBLabel("Annotations:"), topc);
		topc.gridy = 4;
		topc.insets = new Insets(5, 50, 10, 5);
		topc.fill = GridBagConstraints.NONE;
		topc.weighty = 2;
		annotationArea = new AnnotationArea(parent, "");
		annotationArea.getDocument().addDocumentListener(listener);
		topPanel.add(annotationArea, topc);
		jv = new JViewport();
		jv.setView(topPanel);
		JScrollPane jsp =
			new JScrollPane(
				jv,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		jsp.setViewport(jv);
		jsp.setPreferredSize(new Dimension(371, jsp.getPreferredSize().height));
		jsp.setMinimumSize(new Dimension(371, jsp.getPreferredSize().height));
		add(jsp, superc);

		superc.gridy = 1;
		superc.weighty = 0.1;
		superc.fill = GridBagConstraints.BOTH;
		add(new JSeparator(JSeparator.HORIZONTAL), superc);

		VPPanel bottomPanel = new VPPanel();
		bottomPanel.setLayout(new GridBagLayout());
		bottomPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints bottomc = new GridBagConstraints();
		bottomc.anchor = GridBagConstraints.CENTER;
		//bottomc.fill = GridBagConstraints.BOTH;
		bottomc.insets = new Insets(0, 10, 5, 10);
		annotateButton =
			new VPButton("Annotate", ActionCenter.ANNOTATE, listener);
		bottomPanel.add(annotateButton, bottomc);
		bottomc.gridx = 1;
		bottomPanel.add(
			new VPButton("Go To IPA", ActionCenter.GO_TO_IPA, listener),
			bottomc);

		superc.gridy = 2;
		superc.weighty = 0;
		superc.insets = new Insets(5, 5, 0, 5);
		add(bottomPanel, superc);
	}

	public class Listener implements ActionListener, DocumentListener
	{
		/* (non-Javadoc)
		         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		         */
		public void actionPerformed(ActionEvent e)
		{
			String command = e.getActionCommand();
			if (command.equals(ActionCenter.GO_TO_IPA))
			{
				try
				{
					BrowserLauncher.openURL(
						"http://130.132.8.83/hmr/geneDetail.jsp?gid="
							+ gene.get("ID"));
				}
				catch (IOException e1)
				{
					e1.printStackTrace();
				}
			}
			else if (command.equals(ActionCenter.ANNOTATE))
			{
				annotationArea.setAnnotate();
				jv.setViewPosition(
					new Point(
						annotationArea.getBounds().x
							+ annotationArea.getBounds().width,
						annotationArea.getBounds().y
							+ annotationArea.getBounds().height));

				annotationArea.requestFocus();
				annotateButton.setText("Save Note");
				annotateButton.setActionCommand(ActionCenter.SAVE_NOTE);
			}
			else if (command.equals(ActionCenter.SAVE_NOTE))
			{
				annotationArea.setSave();
				//gene.setAnnotation(annotationArea.getText());
				jv.setViewPosition(new Point(0, 0));
				annotateButton.setText("Annotate");
				annotateButton.setActionCommand(ActionCenter.ANNOTATE);
			}
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#changedUpdate(javax.swing.event.DocumentEvent)
		 */
		public void changedUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#insertUpdate(javax.swing.event.DocumentEvent)
		 */
		public void insertUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#removeUpdate(javax.swing.event.DocumentEvent)
		 */
		public void removeUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

	}
}
