/*
 * Created on Jun 8, 2004
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
 * Comments
 */
package vp.gui.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.border.EtchedBorder;

import vp.graph.GraphDataClass;
import vp.graph.PathwayGraph;
import vp.gui.VPSettings;
import vp.gui.components.DialogFactory;
import vp.gui.components.DialogHeader;
import vp.gui.components.VPBLabel;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.gui.components.VPTextField;
import vp.main.MainFrame;
import vp.util.ActionCenter;
import vp.util.IconFactory;
import vp.util.database.DBQuery;

/**
 * @author Matt Holford
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
 * Comments
 */
public class NewPathwayDialog2 extends JDialog
{
    private JComboBox orgsBox;

    private VPTextField pathID;

    private VPPanel rightPanel;

    private JTextArea detailArea;

    private JTextArea pathName;

    private VPTextField orgName;

    private Listener listener;

    private VPPanel leftPanel;

    private GraphDataClass graphData;

    private PathwayGraph pGraph;

    private MainFrame parent;

    public NewPathwayDialog2(MainFrame parent)
    {
        super(parent, "New Pathway", false);
        this.parent = parent;
        listener = new Listener();

        int id = DBQuery.getUniqueID();
        String defaultName = "Pathway" + id;

        getContentPane().setLayout(new GridBagLayout());
        getContentPane().setBackground(VPSettings.Colors.SIDE_PANEL);
        GridBagConstraints superc = new GridBagConstraints();
        superc.anchor = GridBagConstraints.WEST;
        superc.insets = new Insets(5, 8, 5, 5);

        VPPanel p = new DialogHeader(IconFactory.getVPIcon(),
            "Describe the pathway using the menus below");
        superc.gridwidth = 3;
        getContentPane().add(p, superc);

        superc.gridy = 1;
        superc.fill = GridBagConstraints.BOTH;
        JSeparator jsep = new JSeparator(JSeparator.HORIZONTAL);
        getContentPane().add(jsep, superc);

        superc.gridy = 2;
        superc.gridwidth = 1;
        superc.anchor = GridBagConstraints.CENTER;

        VPPanel leftPanel = new VPPanel();
        leftPanel.setLayout(new GridBagLayout());
        leftPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
        GridBagConstraints leftc = new GridBagConstraints();
        leftc.insets = new Insets(5, 5, 5, 5);
        leftc.anchor = GridBagConstraints.WEST;
        leftc.fill = GridBagConstraints.BOTH;
        leftPanel.add(new VPBLabel("ID: "), leftc);
        leftc.gridx = 1;
        leftc.fill = GridBagConstraints.HORIZONTAL;
        pathID = new VPTextField();
        pathID.setText(String.valueOf(id));
        leftPanel.add(pathID, leftc);

        leftc.gridy = 1;
        leftc.gridx = 0;
        leftc.fill = GridBagConstraints.BOTH;
        leftc.gridwidth = 2;
        leftPanel.add(new VPBLabel("Name:"), leftc);

        leftc.gridy = 2;
        int visLines = 3;
        int rowHeight = getFontMetrics(VPSettings.R_FONT).getHeight() + 3;
        pathName = new JTextArea();
        pathName.setFont(VPSettings.R_FONT);
        pathName.setLineWrap(true);
        pathName.setWrapStyleWord(true);
        pathName.setEditable(true);
        pathName.setText(defaultName);
        pathName.setPreferredSize(new Dimension(161, rowHeight
            * visLines));
        pathName.setBorder(new EtchedBorder());
        leftPanel.add(pathName, leftc);

        leftc.gridy = 3;
        leftPanel.add(new VPBLabel("Details:"), leftc);

        leftc.gridy = 4;
        visLines = 4;
        detailArea = new JTextArea();
        detailArea.setFont(VPSettings.R_FONT);
        detailArea.setLineWrap(true);
        detailArea.setWrapStyleWord(true);
        detailArea.setEditable(true);
        detailArea.setPreferredSize(new Dimension(161, rowHeight
            * visLines));
        detailArea.setBorder(new EtchedBorder());
        leftPanel.add(detailArea, leftc);

        getContentPane().add(leftPanel, superc);

        superc.gridx = 1;
        superc.insets = new Insets(8, 10, 5, 10);
        getContentPane().add(new JSeparator(JSeparator.VERTICAL),
            superc);

        superc.gridx = 2;
        rightPanel = new VPPanel();
        rightPanel.setLayout(new GridBagLayout());
        GridBagConstraints rightc = new GridBagConstraints();
        rightPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
        rightc.insets = new Insets(5, 0, 5, 0);
        rightc.gridwidth = 2;
        rightc.fill = GridBagConstraints.BOTH;
        rightc.anchor = GridBagConstraints.WEST;

        rightPanel.add(new VPBLabel("Organism:"), rightc);
        rightc.gridy = 1;
        rightc.insets = new Insets(5, 0, 5, 5);
        rightc.anchor = GridBagConstraints.CENTER;

        List orgs = VPSettings.ORGANISMS;
        Object[] orgStrings = new Object[orgs.size() + 1];
        for (int i = 0; i < orgs.size(); i++)
        {
            orgStrings[i] = (String) orgs.get(i);
        }
        orgStrings[orgs.size()] = "Other";

        orgsBox = new JComboBox(orgStrings);
        orgsBox.setFont(VPSettings.R_FONT);

        orgsBox.setSelectedIndex(0);

        rightPanel.add(orgsBox, rightc);

        rightc.gridy = 2;
        rightc.insets = new Insets(15, 0, 5, 5);
        rightPanel.add(new JSeparator(JSeparator.HORIZONTAL), rightc);

        rightc.gridy = 3;
        rightc.insets = new Insets(5, 0, 6, 5);
        rightc.anchor = GridBagConstraints.WEST;
        rightPanel.add(new VPBLabel("Name:"), rightc);

        rightc.gridy = 4;
        rightc.insets = new Insets(5, 0, 6, 5);
        orgName = new VPTextField();
        if ((graphData != null)
            && (orgsBox.getSelectedItem() == "Other"))
            orgName.setText((String) graphData.get("Organism"));
        rightPanel.add(orgName, rightc);

        rightc.gridy = 5;
        rightc.insets = new Insets(10, 0, 9, 5);
        rightPanel.add(new VPButton("Add Species",
            ActionCenter.ADD_SPECIES, listener), rightc);

        rightc.gridy = 6;
        rightc.insets = new Insets(10, 0, 10, 5);
        rightPanel.add(new JSeparator(JSeparator.HORIZONTAL), rightc);

        rightc.gridy = 7;
        rightc.gridwidth = 1;
        rightc.insets = new Insets(5, 0, 5, 5);
        rightPanel.add(new VPButton("OK", ActionCenter.OK, listener),
            rightc);
        rightc.gridx = 1;
        rightc.insets = new Insets(5, 5, 5, 5);
        rightPanel.add(new VPButton("Cancel", ActionCenter.CANCEL,
            listener), rightc);

        getContentPane().add(rightPanel, superc);

        pack();
        setResizable(false);
        setLocation(
            (parent.getBounds().x + (parent.getBounds().width / 2))
                - (getBounds().width / 2),
            (parent.getBounds().y + (parent.getBounds().height / 2))
                - (getBounds().height / 2));
        addWindowListener(listener);
        show();

        // System.out.println(getPreferredSize());
    }

    public class Listener implements ActionListener, WindowListener
    {

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
         */
        public void actionPerformed(ActionEvent event)
        {
            String command = event.getActionCommand();
            if (command.equals(ActionCenter.OK))
            {
                GraphDataClass newPath = new GraphDataClass(pathID
                    .getText());
                newPath.put("id", pathID.getText());
                newPath.put("Name", pathName.getText());
                newPath.put("Details", detailArea.getText());

                if (!orgsBox.getSelectedItem().equals("Other"))
                {
                    newPath
                        .put("Organism", orgsBox.getSelectedItem());
                }
                else
                {
                    newPath.put("Organism", orgName.getText());
                }

                parent.setGraphDataClass(newPath);

                parent.showNewGraph();
                dispose();
            }
            else if (command.equals(ActionCenter.CANCEL))
                dispose();
            else if (command.equals(ActionCenter.ADD_SPECIES))
            {
                String title = "Not enabled";
                String header = "Feature not yet enabled!";
                String body = "This feature has not yet been "
                    + "\nenabled.   Please check future"
                    + "\nversions for availability";
                DialogFactory.createDialog(parent, IconFactory
                    .getVPIcon(), title, header, body,
                    DialogFactory.OK_ONLY);
            }
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowActivated(java.awt.event.WindowEvent)
         */
        public void windowActivated(WindowEvent e)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowClosed(java.awt.event.WindowEvent)
         */
        public void windowClosed(WindowEvent e)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowClosing(java.awt.event.WindowEvent)
         */
        public void windowClosing(WindowEvent e)
        {
            dispose();
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowDeactivated(java.awt.event.WindowEvent)
         */
        public void windowDeactivated(WindowEvent e)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowDeiconified(java.awt.event.WindowEvent)
         */
        public void windowDeiconified(WindowEvent e)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowIconified(java.awt.event.WindowEvent)
         */
        public void windowIconified(WindowEvent e)
        {
        }

        /*
         * (non-Javadoc)
         * 
         * @see java.awt.event.WindowListener#windowOpened(java.awt.event.WindowEvent)
         */
        public void windowOpened(WindowEvent e)
        {
        }

    }
}
