/*
 * Created on Jun 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.List;

import javax.swing.JComboBox;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.border.EtchedBorder;

import vp.graph.GraphDataClass;
import vp.graph.PathwayGraph;
import vp.gui.VPSettings;
import vp.gui.components.DialogFactory;
import vp.gui.components.DialogHeader;
import vp.gui.components.VPBLabel;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.gui.components.VPTextField;
import vp.main.MainFrame;
import vp.util.ActionCenter;
import vp.util.IconFactory;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PathwayDetailsDialog extends VPPanel
{
	private JComboBox orgsBox;

	private VPTextField pathID;

	private VPPanel rightPanel;

	private JTextArea detailArea;

	private JTextArea pathName;

	private VPTextField orgName;

	private Listener listener;

	private VPPanel leftPanel;

	private GraphDataClass graphData;

	private PathwayGraph pGraph;

	private MainFrame parent;

	public PathwayDetailsDialog(MainFrame parent)
	{
		this.parent = parent;
		pGraph = parent.getPathwayGraph();
		graphData = pGraph.getGraphDataClass();
		listener = new Listener();

		setLayout(new GridBagLayout());
		setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints superc = new GridBagConstraints();
		superc.anchor = GridBagConstraints.WEST;
		superc.insets = new Insets(5, 8, 5, 5);

		VPPanel p =
			new DialogHeader(
				IconFactory.getVPIcon(),
				"Describe the pathway using the menus below");
		superc.gridwidth = 3;
		add(p, superc);

		superc.gridy = 1;
		superc.fill = GridBagConstraints.BOTH;
		JSeparator jsep = new JSeparator(JSeparator.HORIZONTAL);
		add(jsep, superc);

		superc.gridy = 2;
		superc.gridwidth = 1;
		superc.anchor = GridBagConstraints.CENTER;

		VPPanel leftPanel = new VPPanel();
		leftPanel.setLayout(new GridBagLayout());
		leftPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints leftc = new GridBagConstraints();
		leftc.insets = new Insets(5, 5, 5, 5);
		leftc.anchor = GridBagConstraints.WEST;
		leftc.fill = GridBagConstraints.BOTH;
		leftPanel.add(new VPBLabel("ID: "), leftc);
		leftc.gridx = 1;
		leftc.fill = GridBagConstraints.HORIZONTAL;
		pathID = new VPTextField();
		if (graphData != null)
			pathID.setText((String)graphData.get("id"));
		leftPanel.add(pathID, leftc);

		leftc.gridy = 1;
		leftc.gridx = 0;
		leftc.fill = GridBagConstraints.BOTH;
		leftc.gridwidth = 2;
		leftPanel.add(new VPBLabel("Name:"), leftc);

		leftc.gridy = 2;
		int visLines = 3;
		int rowHeight = getFontMetrics(VPSettings.R_FONT).getHeight() + 3;
		pathName = new JTextArea();
		pathName.setFont(VPSettings.R_FONT);
		pathName.setLineWrap(true);
		pathName.setWrapStyleWord(true);
		pathName.setEditable(true);
		if (graphData != null)
			pathName.setText((String)graphData.get("Name"));
		pathName.setPreferredSize(new Dimension(161, rowHeight * visLines));
		pathName.setBorder(new EtchedBorder());
		leftPanel.add(pathName, leftc);

		leftc.gridy = 3;
		leftPanel.add(new VPBLabel("Details:"), leftc);

		leftc.gridy = 4;
		visLines = 4;
		detailArea = new JTextArea();
		detailArea.setFont(VPSettings.R_FONT);
		detailArea.setLineWrap(true);
		detailArea.setWrapStyleWord(true);
		detailArea.setEditable(true);
		if ((graphData != null) && (graphData.get("Details") != null))
			detailArea.setText((String)graphData.get("Details"));
		detailArea.setPreferredSize(new Dimension(161, rowHeight * visLines));
		detailArea.setBorder(new EtchedBorder());
		leftPanel.add(detailArea, leftc);

		add(leftPanel, superc);

		superc.gridx = 1;
		superc.insets = new Insets(8, 10, 5, 10);
		add(new JSeparator(JSeparator.VERTICAL), superc);

		superc.gridx = 2;
		rightPanel = new VPPanel();
		rightPanel.setLayout(new GridBagLayout());
		GridBagConstraints rightc = new GridBagConstraints();
		rightPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
		rightc.insets = new Insets(5, 0, 5, 0);
		rightc.gridwidth = 2;
		rightc.fill = GridBagConstraints.BOTH;
		rightc.anchor = GridBagConstraints.WEST;

		rightPanel.add(new VPBLabel("Organism:"), rightc);
		rightc.gridy = 1;
		rightc.insets = new Insets(5, 0, 5, 5);
		rightc.anchor = GridBagConstraints.CENTER;

		List orgs = VPSettings.ORGANISMS;
		String[] orgStrings = new String[orgs.size() + 1];
		for (int i = 0; i < orgs.size(); i++)
		{
			orgStrings[i] = (String)orgs.get(i);
		}
		orgStrings[orgs.size()] = "Other";

		orgsBox = new JComboBox(orgStrings);
		orgsBox.setFont(VPSettings.R_FONT);

		if (graphData.get("Organism") == null)
			orgsBox.setSelectedIndex(0);
		else if (!orgs.contains((String)graphData.get("Organism")))
			orgsBox.setSelectedIndex(orgs.size());
		else
			orgsBox.setSelectedItem((String)graphData.get("Organism"));

		rightPanel.add(orgsBox, rightc);

		rightc.gridy = 2;
		rightc.insets = new Insets(15, 0, 5, 5);
		rightPanel.add(new JSeparator(JSeparator.HORIZONTAL), rightc);

		rightc.gridy = 3;
		rightc.insets = new Insets(5, 0, 6, 5);
		rightc.anchor = GridBagConstraints.WEST;
		rightPanel.add(new VPBLabel("Name:"), rightc);

		rightc.gridy = 4;
		rightc.insets = new Insets(5, 0, 6, 5);
		orgName = new VPTextField();
		if ((graphData.get("Organism") != null)
			&& (orgsBox.getSelectedItem() == "Other"))
			orgName.setText((String)graphData.get("Organism"));
		rightPanel.add(orgName, rightc);

		rightc.gridy = 5;
		rightc.insets = new Insets(10, 0, 9, 5);
		rightPanel.add(
			new VPButton("Add Species", ActionCenter.ADD_SPECIES, listener),
			rightc);

		rightc.gridy = 6;
		rightc.insets = new Insets(10, 0, 10, 5);
		rightPanel.add(new JSeparator(JSeparator.HORIZONTAL), rightc);

		rightc.gridy = 7;
		rightc.gridwidth = 1;
		rightc.insets = new Insets(5, 0, 5, 5);
		rightPanel.add(new VPButton("OK", ActionCenter.OK, listener), rightc);
		rightc.gridx = 1;
		rightc.insets = new Insets(5, 5, 5, 5);
		rightPanel.add(
			new VPButton("Cancel", ActionCenter.CANCEL, listener),
			rightc);

		add(rightPanel, superc);

		//System.out.println(getPreferredSize());
	}

	public class Listener implements ActionListener
	{

		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent event)
		{
			String command = event.getActionCommand();
			if (command.equals(ActionCenter.OK))
			{
				if ((pathID.getText() != graphData.get("id"))
					|| (pathName.getText() != graphData.get("Name")))
				{
					GraphDataClass newDataClass =
						new GraphDataClass(pathID.getText());
					newDataClass.put("Name", pathName.getText());
					newDataClass.put("Details", detailArea.getText());
					pGraph.setGraphDataClass(newDataClass);
				}

				if (!orgsBox.getSelectedItem().equals("Other"))
				{
					if (orgsBox.getSelectedItem() != graphData.get("Organism"))
					{
						pGraph.getGraphDataClass().put("Organism", orgsBox.getSelectedItem());
					}
				}
				else
				{
					pGraph.getGraphDataClass().put("Organism", orgName.getText());
				}

				parent.clearEditPanel();
				parent.addToDisplayPanel(new PathwayDisplayPanel(parent));
			}
			else if (command.equals(ActionCenter.CANCEL))
				parent.clearEditPanel();
			else if (command.equals(ActionCenter.ADD_SPECIES))
			{
				String title = "Not enabled";
				String header = "Feature not yet enabled!";
				String body =
					"This feature has not yet been "
						+ "\nenabled.   Please check future"
						+ "\nversions for availability";
				DialogFactory.createDialog(
					parent,
					IconFactory.getVPIcon(),
					title,
					header,
					body,
					DialogFactory.OK_ONLY);
			}
		}

	}
}