/*
 * Created on Mar 18, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.dialogs;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.IOException;

import javax.swing.JScrollPane;
import javax.swing.JSeparator;
import javax.swing.JViewport;
import javax.swing.UIManager;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;

import vp.graph.GraphDataClass;
import vp.graph.PathwayGraph;
import vp.gui.VPSettings;
import vp.gui.components.AnnotationArea;
import vp.gui.components.VPBLabel;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.gui.components.VPRLabel;
import vp.gui.kunststoff.KunststoffSeparatorUI;
import vp.main.MainFrame;
import vp.util.ActionCenter;
import vp.util.BrowserLauncher;
import vp.util.StringBreaker;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class PathwayDisplayPanel extends VPPanel
{

	private VPBLabel pathwayLabel;
	private VPButton annotateButton;
	private VPBLabel annotationLabel;
	private JViewport jv;
	private AnnotationArea annotationArea;
	private MainFrame parent;
	private PathwayGraph pGraph;
    private GraphDataClass pathway;

	public PathwayDisplayPanel(MainFrame parent)
	{
		this.parent = parent;
		pGraph = parent.getPathwayGraph();
        pathway = pGraph.getGraphDataClass();
		Listener listener = new Listener();
		setLayout(new GridBagLayout());
		setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints superc = new GridBagConstraints();
        
		superc.anchor = GridBagConstraints.WEST;
		superc.insets = new Insets(5, 5, 5, 5);
        superc.fill = GridBagConstraints.BOTH;
        superc.weighty = 2.0;

		VPPanel topPanel = new VPPanel();
		topPanel.setLayout(new GridBagLayout());
		topPanel.setBackground(VPSettings.Colors.SIDE_PANEL);

		GridBagConstraints topc = new GridBagConstraints();
		Insets regular = new Insets(0, 10, 0, 5);
		Insets indent = new Insets(0, 50, 5, 5);
		topc.anchor = GridBagConstraints.WEST;
		topc.fill = GridBagConstraints.BOTH;
		topc.weightx = 2;
		topc.insets = new Insets(10, 10, 0, 5);
		pathwayLabel = new VPBLabel("Pathway:");
		topPanel.add(pathwayLabel, topc);
		topc.gridy = 1;
		topc.insets = indent;
		String pathwayName =
			(pGraph.getGraphDataClass() != null)
				? StringBreaker.breakStringForLabel(
					(String)pGraph.getGraphDataClass().get("Name"),
					50)
				: "N/A";
		topPanel.add(new VPRLabel(pathwayName), topc);
		topc.gridy = 2;
		topc.insets = regular;
		topPanel.add(new VPBLabel("Species:"), topc);
		topc.gridy = 3;
		topc.insets = indent;
		String speciesName =
			(pGraph.getGraphDataClass().get("Organism") != null)
				? (String)pGraph.getGraphDataClass().get("Organism")
				: "N/A";
		topPanel.add(new VPRLabel(speciesName), topc);
		topc.gridy = 4;
		topc.insets = regular;
		topPanel.add(new VPBLabel("Experiment:"), topc);
		topc.gridy = 5;
		topc.insets = indent;
		String experimentName =
			(pGraph.getExperiment() != null)
				? pGraph.getExperiment().getName()
				: "N/A";
		topPanel.add(new VPRLabel(experimentName), topc);
		topc.gridy = 6;
		topc.insets = regular;
		annotationLabel = new VPBLabel("Annotations:");
		topPanel.add(annotationLabel, topc);
		topc.gridy = 7;
		topc.insets = indent;
		topc.fill = GridBagConstraints.NONE;
		topc.weighty = 1;
        
        String annotation = (String) pathway.get("annotation");
        annotation = (annotation == null) ? "" : annotation;
        annotationArea = new AnnotationArea(parent, annotation);
		annotationArea.getDocument().addDocumentListener(listener);
		topPanel.add(annotationArea, topc);
        
        topc.gridy = 8;
        topc.weighty = 2;
        topPanel.add(new VPPanel(), topc);
        
		jv = new JViewport();
		jv.setView(topPanel);
		JScrollPane jsp =
			new JScrollPane(
				jv,
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		UIManager.put("ScrollBar.background", VPSettings.Colors.SIDE_PANEL);
		jsp.setViewport(jv);
        
		jsp.setPreferredSize(new Dimension(371, jsp.getPreferredSize().height));
        jsp.setMinimumSize(new Dimension(371, jsp.getPreferredSize().height));
        add(jsp, superc);

		superc.gridy = 1;
		superc.fill = GridBagConstraints.BOTH;
        superc.weighty = 0.1;
        JSeparator jsep = new JSeparator(JSeparator.HORIZONTAL);
        jsep.setUI(new KunststoffSeparatorUI());
		add(jsep, superc);

		VPPanel bottomPanel = new VPPanel();
		bottomPanel.setLayout(new GridBagLayout());
		bottomPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints bottomc = new GridBagConstraints();
		bottomc.anchor = GridBagConstraints.CENTER;
		//bottomc.fill = GridBagConstraints.BOTH;
		bottomc.insets = new Insets(0, 10, 5, 10);
		annotateButton =
			new VPButton("Annotate", ActionCenter.ANNOTATE, listener);
		bottomPanel.add(annotateButton, bottomc);
		bottomc.gridx = 1;
		bottomPanel.add(
			new VPButton("Go To KEGG", ActionCenter.GO_TO_KEGG, listener),
			bottomc);

		superc.gridy = 2;
        superc.weighty = 0;
        superc.insets = new Insets(5, 5, 0, 5);
		add(bottomPanel, superc);

	}
	/**
	* @author Matt
	*
	* To change the template for this generated type comment go to
	* Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	*/
	private class Listener implements ActionListener, DocumentListener
	{

		/* (non-Javadoc)
		 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
		 */
		public void actionPerformed(ActionEvent e)
		{
			String command = e.getActionCommand();
			if (command.equals(ActionCenter.GO_TO_KEGG))
			{
				try
				{
					BrowserLauncher.openURL(
						"http://www.genome.ad.jp/kegg/pathway/map/map"
							+ ((String)pGraph.getGraphDataClass().get("Name")).substring(3)
							+ ".html");
				}
				catch (IOException e1)
				{
					e1.printStackTrace();
				}
			}
			else if (command.equals(ActionCenter.ANNOTATE))
			{
				annotationArea.setAnnotate();
				jv.setViewPosition(
					new Point(
						annotationArea.getBounds().x
							+ annotationArea.getBounds().width,
						annotationArea.getBounds().y
							+ annotationArea.getBounds().height));

				annotationArea.requestFocus();
				annotateButton.setText("Save Note");
				annotateButton.setActionCommand(ActionCenter.SAVE_NOTE);
				parent.getAlertField().setVisible(false);
				parent.getProgBar().setVisible(false);
			}
			else if (command.equals(ActionCenter.SAVE_NOTE))
			{
				annotationArea.setSave();
                //vGraph.setAnnotation(annotationArea.getText());
				jv.setViewPosition(new Point(0, 0));
				annotateButton.setText("Annotate");
				annotateButton.setActionCommand(ActionCenter.ANNOTATE);
                pathway.put("annotation", annotationArea.getText());
			}
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#changedUpdate(javax.swing.event.DocumentEvent)
		 */
		public void changedUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#insertUpdate(javax.swing.event.DocumentEvent)
		 */
		public void insertUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

		/* (non-Javadoc)
		 * @see javax.swing.event.DocumentListener#removeUpdate(javax.swing.event.DocumentEvent)
		 */
		public void removeUpdate(DocumentEvent e)
		{
			annotationArea.noteChange();
		}

	}
}
