/*
 * Created on Mar 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.dialogs;

import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.util.List;

import javax.swing.JLabel;

import vp.graph.DataClass;
import vp.gui.VPSettings;
import vp.gui.components.VPPanel;
import vp.gui.components.VPRLabel;
import vp.main.MainFrame;
import vp.util.StringBreaker;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ReactionPanel extends VPPanel
{
	/**
	 * @author Matt
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private class RPLabel extends JLabel
	{
		RPLabel(String label)
		{
			super(label);
			setFont(VPSettings.R_FONT);
			//setBorder(null);
		}
	}

	private class RPBLabel extends JLabel
	{
		RPBLabel(String label)
		{
			super(label);
			setFont(new Font("Palatino Linotype", Font.BOLD, 18));
		}
	}
	private long startTime;

	private List products;

	private List substrates;
	private MainFrame parent;
	private DataClass enzyme;

	public ReactionPanel(MainFrame parent, DataClass enzyme)
	{
		startTime = System.currentTimeMillis();
		this.enzyme = enzyme;
		this.parent = parent;
		substrates = (List)enzyme.get("Substrates");
		products = (List)enzyme.get("Products");

		setLayout(new GridBagLayout());
		setBackground(VPSettings.Colors.SIDE_PANEL);
		GridBagConstraints superc = new GridBagConstraints();

		if (substrates != null)
		{
			superc.anchor = GridBagConstraints.WEST;
			superc.insets = new Insets(0, 5, 0, 10);
			superc.fill = GridBagConstraints.VERTICAL;

			VPPanel leftPanel = new VPPanel();
			leftPanel.setLayout(new GridBagLayout());
			leftPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
			GridBagConstraints secondc = new GridBagConstraints();

			secondc.fill = GridBagConstraints.VERTICAL;
			for (int i = 0; i < substrates.size(); i++)
			{
				secondc.gridy = 2 * i;
				secondc.anchor = GridBagConstraints.CENTER;
				leftPanel.add(
					new RPLabel(
						StringBreaker.breakStringForLabel((String)substrates.get(i))),
					secondc);
				if (i < substrates.size() - 1)
				{
					secondc.gridy = secondc.gridy + 1;
					secondc.anchor = GridBagConstraints.CENTER;
					leftPanel.add(new RPBLabel("+"), secondc);
				}

			}

			superc.gridx = 0;
			add(leftPanel, superc);

			VPPanel centerPanel = new VPPanel();
			centerPanel.setLayout(new GridBagLayout());
			centerPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
			centerPanel.add(new RPBLabel("="));
			superc.gridx = 1;
			superc.insets = new Insets(0, 10, 0, 10);
			add(centerPanel, superc);

			VPPanel rightPanel = new VPPanel();
			rightPanel.setLayout(new GridBagLayout());
			rightPanel.setBackground(VPSettings.Colors.SIDE_PANEL);
			GridBagConstraints fourthc = new GridBagConstraints();

			fourthc.fill = GridBagConstraints.VERTICAL;
			for (int i = 0; i < products.size(); i++)
			{
				fourthc.gridy = 2 * i;
				fourthc.anchor = GridBagConstraints.CENTER;
				rightPanel.add(
					new RPLabel(StringBreaker.breakStringForLabel((String)products.get(i))),
					fourthc);
				if (i < products.size() - 1)
				{
					fourthc.gridy = fourthc.gridy + 1;
					fourthc.anchor = GridBagConstraints.CENTER;
					rightPanel.add(new RPBLabel("+"), fourthc);
				}
			}
			superc.gridx = 2;
			superc.weightx = 2;
			add(rightPanel, superc);

		}
		else
		{
			superc.anchor = GridBagConstraints.WEST;
			superc.fill = GridBagConstraints.BOTH;
			superc.weightx = 2;
			add(new VPRLabel("Reaction not available"), superc);
		}
		parent.getAlertField().setText("");
		parent.getAlertField().setVisible(false);
		parent.getProgBar().setVisible(false);
	}

}
