package vp.gui.kunststoff;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

import javax.swing.JComponent;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicMenuBarUI;

/*
 * This code was developed by INCORS GmbH (www.incors.com).
 * It is published under the terms of the GNU Lesser General Public License.
 */

public class KunststoffMenuBarUI extends BasicMenuBarUI
{

	public static ComponentUI createUI(JComponent x)
	{
		return new KunststoffMenuBarUI();
	}

	public void paint(Graphics g, JComponent c)
	{
		super.paint(g, c);
		// paint upper gradient
		Color colorReflection =
			KunststoffLookAndFeel.getComponentGradientColorReflection();
		if (colorReflection != null)
		{
			Color colorReflectionFaded =
				KunststoffUtilities.getTranslucentColor(colorReflection, 0);
			Rectangle rect =
				new Rectangle(0, 0, c.getWidth(), c.getHeight() / 2);
			KunststoffUtilities.drawGradient(
				g,
				colorReflection,
				colorReflectionFaded,
				rect,
				true);
		}

		// paint lower gradient
		Color colorShadow =
			KunststoffLookAndFeel.getComponentGradientColorShadow();
		if (colorShadow != null)
		{
			Color colorShadowFaded =
				KunststoffUtilities.getTranslucentColor(colorShadow, 0);
			Rectangle rect =
				new Rectangle(
					0,
					c.getHeight() / 2,
					c.getWidth(),
					c.getHeight() / 2);
			KunststoffUtilities.drawGradient(
				g,
				colorShadowFaded,
				colorShadow,
				rect,
				true);
		}
	}

}