package vp.gui.kunststoff;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JComponent;
import javax.swing.JSeparator;
import javax.swing.UIDefaults;
import javax.swing.UIManager;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicSeparatorUI;

import vp.gui.VPSettings;

public class KunststoffSeparatorUI extends BasicSeparatorUI
{
	private final static KunststoffSeparatorUI separatorUI =
		new KunststoffSeparatorUI();

	public static ComponentUI createUI(JComponent c)
	{
		return separatorUI;
	}

	public Dimension getPreferredSize(JComponent c)
	{
		if (((JSeparator)c).getOrientation() == JSeparator.VERTICAL)
			return new Dimension(2, 0);
		else
			return new Dimension(0, 2);
	}

	public Dimension getMaximumSize(JComponent c)
	{
		return null;
	}

	public Dimension getMinimumSize(JComponent c)
	{
		return null;
	}

	public void paint(Graphics g, JComponent c)
	{
		Dimension s = c.getSize();
		UIDefaults table = UIManager.getLookAndFeelDefaults();
		Color shadow = VPSettings.Colors.M_BLUE;
		Color highlight = Color.white;

		if (((JSeparator)c).getOrientation() == JSeparator.VERTICAL)
		{
			int x = (s.width / 2) - 1;
			g.setColor(shadow);
			g.drawLine(x, 5, x, s.height - 5);

			g.setColor(highlight);
			g.drawLine(x + 1, 5, x + 1, s.height - 5);
		}
		else
		{
			int y = (s.height / 2) - 1;
			g.setColor(shadow);
			g.drawLine(5, y, s.width - 5, y);

			g.setColor(highlight);
			g.drawLine(5, y + 1, s.width - 5, y + 1);
		}
	}
}