package vp.gui.table;

import java.util.Comparator;


public class ColumnSorter implements Comparator
{
	private int colIndex;
	private boolean ascending;

	public ColumnSorter(int colIndex, boolean ascending)
	{
		this.colIndex = colIndex;
		this.ascending = ascending;
	}

	public int compare(Object a, Object b)
	{
		VPData v1 = (VPData)a;
		VPData v2 = (VPData)b;
		Object o1 = v1.getData(colIndex);
		Object o2 = v2.getData(colIndex);

		if(o1 instanceof String)
		{
			o1 = ((String)o1).toUpperCase();
			if (((String)o1).length() == 0 || ((String)o1).equals("N/A"))
				o1 = null;
		}
		if(o2 instanceof String)
		{
			o2 = ((String)o2).toUpperCase();
			if(((String)o2).length() == 0 || ((String)o2).equals("N/A"))
				o2 = null;
		}

		if(o1 instanceof Boolean)
			o1 = (((Boolean)o1).booleanValue()) ? new String("appear") : new String("hide");

		if(o2 instanceof Boolean)
			o2 = (((Boolean)o2).booleanValue()) ? new String("appear") : new String("hide");

		if(o1 == null && o2 == null)
			return 0;
		else if(o1 == null)
			return 1;
		else if(o2 == null)
			return -1;
		else if (o1 instanceof Comparable)
		{
			if(ascending)
				return ((Comparable)o1).compareTo(o2);
			else
				return ((Comparable)o2).compareTo(o1);
		}

		else
		{
			if(ascending)
				return o1.toString().toUpperCase().compareTo(o2.toString().toUpperCase());
			else
				return o2.toString().toUpperCase().compareTo(o1.toString().toUpperCase());
		}
	}
}
