package vp.gui.table;

import vp.gui.table.components.*;
import vp.visual.type.Type;

import java.util.ArrayList;

public class CompoundData implements VPData
{
	private Boolean show;
	private String name;
	private Type type;
	private ArrayList connects;
	private Integer xPos;
	private Integer yPos;
	private int connectsValue;

	public CompoundData(
		boolean show,
		String name,
		Type type,
		ArrayList connects,
		int xPos,
		int yPos)
	{
		this.show = new Boolean(show);
		this.name = name;
		this.type = type;
		this.connects = connects;
		this.xPos = new Integer(xPos);
		this.yPos = new Integer(yPos);
		connectsValue = 0;
	}

	public Object get(VPTable table, int row, int col)
	{
		VPCellComponent vpcc;
		VPTableButton vptb;
		VPTableComponent vptc;

		switch (col)
		{
			case 0 :
				vpcc = new CheckCellComponent(show, row, col);
				vptb = new VPTableButton(VPTableButton.EDIT);
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			case 1 :
				vpcc = new PlainCellComponent(name, row, col);
				vptb = new VPTableButton(VPTableButton.LOOKUP);
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			case 2 :
				vpcc = new TypeCellComponent(table, type, row, col);
				vptb = null;
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			case 3 :
				vpcc = new ArrayCellComponent(table, connects, row, col);
				vptb = new VPTableButton(VPTableButton.GOTO);
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			case 4 :
				vpcc = new PlainCellComponent(xPos, row, col);
				vptb = null;
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			case 5 :
				vpcc = new PlainCellComponent(yPos, row, col);
				vptb = null;
				vptc = new VPTableComponent(table, vpcc, vptb);
				return vptc;
			default :
				return new Object();
		}
	}

	public int getConnectsValue()
	{
		return connectsValue;
	}

	public void setConnectsValue(int connectsValue)
	{
		this.connectsValue = connectsValue;
	}

	public Boolean getShow()
	{
		return show;
	}

	public void setShow(boolean show)
	{
		this.show = new Boolean(show);
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public Type getType()
	{
		return type;
	}

	public void setType(Type type)
	{
		this.type = type;
	}

	public ArrayList getConnects()
	{
		return connects;
	}

	public void setConnects(ArrayList connects)
	{
		this.connects = connects;
	}

	public Integer getXPos()
	{
		return xPos;
	}

	public void setXPos(int xPos)
	{
		this.xPos = new Integer(xPos);
	}

	public Integer getYPos()
	{
		return yPos;
	}

	public void setYPos(int yPos)
	{
		this.yPos = new Integer(yPos);
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPData#getData(int)
	 */
	public Object getData(int index)
	{
		switch (index)
		{
			case 0 :
				return show;
			case 1 :
				return name;
			case 2 :
				return type;
			case 3 :
				return connects;
			case 4 :
				return xPos;
			case 5 :
				return yPos;
			default :
				return new Object();
		}
	}
}
