package vp.gui.table;

import vp.graph.Edge;
import vp.graph.PathwayGraph;
import vp.graph.PathwayVertex;
import vp.visual.type.Type;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Vector;
import javax.swing.JLabel;

public class CompoundTableData extends VPTableData
{

	private PathwayGraph pGraph;

	public CompoundTableData(PathwayGraph pGraph, VPTable vpTable)
	{
		this.pGraph = pGraph;
		this.vpTable = vpTable;
		columns = new ColumnData[6];
		columns[0] = new ColumnData("?", 45, JLabel.CENTER, true);
		columns[1] = new ColumnData("Name", 160, JLabel.LEFT, true);
		columns[2] = new ColumnData("Type", 120, JLabel.LEFT, false);
		columns[3] = new ColumnData("Connects", 160, JLabel.LEFT, false);
		columns[4] = new ColumnData("X", 35, JLabel.CENTER, true);
		columns[5] = new ColumnData("Y", 35, JLabel.CENTER, true);
		v = new Vector();
		setData(pGraph);
	}

	public void setData(PathwayGraph pGraph)
	{
		v.removeAllElements();
		ListIterator viter = pGraph.getVertexIterator();
		while (viter.hasNext())
		{
			PathwayVertex current = (PathwayVertex)viter.next();
			String name = current.getLabel();
			Type type = current.getType();

			List hs = pGraph.getEdges(current);
			ArrayList connects = new ArrayList();
			Iterator hsit = hs.iterator();
			while (hsit.hasNext())
			{
				Edge edge = (Edge)hsit.next();
				String conn =
					(edge.getOppositeVertex(current)).getObject().toString();
				connects.add(conn);
			}
			int xPos = current.getXPosition();
			int yPos = current.getYPosition();

			v.addElement(
				new CompoundData(true, name, type, connects, xPos, yPos));
		}
	}

	public Object getValueAt(int nRow, int nCol)
	{
		CompoundData row = (CompoundData)v.elementAt(nRow);
		return row.get(vpTable, nRow, nCol);
	}

	public void setValueAt(Object value, int nRow, int nCol)
	{
		CompoundData row = (CompoundData)v.elementAt(nRow);
		switch (nCol)
		{
			case 0 :
				row.setShow(((Boolean)value).booleanValue());
				break;
		}
	}
}
