package vp.gui.table;

import vp.gui.table.components.*;
import vp.visual.type.Type;

public class EnzymeData implements VPData
{
	private Boolean show;
	private String name;
	private Type type;
	private String link;
	private String expression;
	
	public EnzymeData(boolean show, String name, Type type, String link, String expression)
	{
		this.show = new Boolean(show);
		this.name = name;
		this.type = type;
		this.link = link;
		this.expression = expression;
	}

	public Object getData(int index)
	{
		switch (index)
		{
		case 0:
			return show;
		case 1:
			return name;
		case 2:
			return type;
		case 3:
			return link;
		case 4:
			return expression;
		default:
			return new Object();
		}
	}

	public Boolean getShow()
	{
		 return show;
	}

	public void setShow(boolean show)
	{
		this.show = new Boolean(show);
	}

	public String getName()
	{
		return name;
	}

	public void setName(String name)
	{
		this.name = name;
	}

	public Type getType()
	{
		return type;
	}

	public void setType(Type type)
	{
		this.type = type;
	}

	public String getLink()
	{
		return  link;
	}

	public void setLink(String link)
	{
		this.link = link;
	}

	public String getExpression()
	{
		return expression;
	}

	public void setExpression(String expression)
	{
		this.expression = expression;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPData#get(javax.swing.JTable, int, int)
	 */
	public Object get(VPTable table, int row, int col)
	{
		VPCellComponent vpcc;
		VPTableButton vptb;
		VPTableComponent vptc;
		
		switch(col)
		{
		case 0:
			vpcc = new CheckCellComponent(show, row, col);
			vptb = new VPTableButton(VPTableButton.EDIT);
			vptc = new VPTableComponent(table, vpcc, vptb);
			return vptc;
		case 1:
			vpcc = new PlainCellComponent(name, row, col);
			vptb = new VPTableButton(VPTableButton.LOOKUP);
			vptc = new VPTableComponent(table, vpcc, vptb);
			return vptc;
		case 2:
			vpcc = new TypeCellComponent(table, type, row, col);
			vptb = null;
			vptc = new VPTableComponent(table, vpcc, vptb);
			return vptc;
		case 3:
			vpcc = new PlainCellComponent(link, row, col);
			vptb = new VPTableButton(VPTableButton.GOTO);
			vptc = new VPTableComponent(table, vpcc, vptb);
			return vptc;
		case 4:
			vpcc = new PlainCellComponent(expression, row, col);
			vptb = null;
			vptc = new VPTableComponent(table, vpcc, vptb);
			return vptc;
		default:
			return new Object();
		}
	}

}
