package vp.gui.table;

import vp.graph.Edge;
import vp.graph.PathwayDecoration;
import vp.graph.PathwayEdge;
import vp.graph.PathwayGraph;
import vp.visual.type.Type;

import java.util.ListIterator;
import java.util.Vector;
import javax.swing.JLabel;

public class EnzymeTableData extends VPTableData
{

	private PathwayGraph pGraph;

	public EnzymeTableData(PathwayGraph pGraph, VPTable vpTable)
	{
		this.pGraph = pGraph;
		this.vpTable = vpTable;
		columns = new ColumnData[5];
		columns[0] = new ColumnData("?", 45, JLabel.CENTER, true);
		columns[1] = new ColumnData("Name", 100, JLabel.LEFT, true);
		columns[2] = new ColumnData("Type", 120, JLabel.LEFT, false);
		columns[3] = new ColumnData("Link", 160, JLabel.LEFT, true);
		columns[4] = new ColumnData("Value", 80, JLabel.CENTER, true);
		v = new Vector();
		setData(pGraph);
	}

	public void setData(PathwayGraph pGraph)
	{
		v.removeAllElements();
		ListIterator eiter = pGraph.getEdgeIterator();
		while (eiter.hasNext())
		{
			PathwayEdge currEdge = (PathwayEdge)eiter.next();

			ListIterator viter = currEdge.getDecorationIterator();
			while (viter.hasNext())
			{
				PathwayDecoration current = (PathwayDecoration)viter.next();
				String name = current.getLabel();
				Type type = current.getType();

				String link = ((Edge)current.getParent()).toString();
				if (current.getDataClass().getClassName().equals("Enzyme"))
				{
					String exp =
						(current.getDataClass().get("Expression")) == null
							? "N/A"
							: (String)current.getDataClass().get("Expression");

					v.addElement(new EnzymeData(true, name, type, link, exp));
				}
			}
		}
	}

	public Object getValueAt(int nRow, int nCol)
	{
		EnzymeData row = (EnzymeData)v.elementAt(nRow);
		return row.get(vpTable, nRow, nCol);
	}

	public void setValueAt(Object value, int nRow, int nCol)
	{
		EnzymeData row = (EnzymeData)v.elementAt(nRow);
		switch (nCol)
		{
			case 0 :
				row.setShow(((Boolean)value).booleanValue());
		}
	}
}
