package vp.gui.table;

import java.util.Vector;
import javax.swing.table.AbstractTableModel;

import vp.graph.PathwayGraph;

public abstract class VPTableData extends AbstractTableModel
{
	ColumnData[] columns;
	PathwayGraph pGraph;
	Vector v;
	VPTable vpTable;

	public int getColumnCount()
	{
		return columns.length;
	}

	public ColumnData getColumn(int index)
	{
		return columns[index];
	}

	public int getRowCount()
	{
		return v == null ? 0 : v.size();
	}

	public boolean isCellEditable(int nRow, int nCol)
	{
		return true;
	}

	public String getColumnName(int column)
	{
		return getColumn(column).getName();
	}

	public Vector getDataVector()
	{
		return v;
	}

	public abstract void setData(PathwayGraph vGraph);
	public abstract Object getValueAt(int nRow, int nCol);
	public abstract void setValueAt(Object value, int nRow, int nCol);
}
