/*
 * Created on Mar 4, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.gui.table;

import java.awt.Component;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import javax.swing.JScrollPane;
import javax.swing.JViewport;

import vp.gui.table.components.*;

/**
 * @author matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VPTableListener implements MouseListener, MouseMotionListener
{

	private VPTable vpTable;

	/**
	 * 
	 */
	public VPTableListener(VPTable vpTable)
	{
		this.vpTable = vpTable;
	}

	public void mousePressed(MouseEvent e)
	{
		int row = vpTable.rowAtPoint(new Point(e.getX(), e.getY()));
		int col = vpTable.columnAtPoint(new Point(e.getX(), e.getY()));
		Object o = vpTable.getValueAt(row, col);

		if (o instanceof VPTableComponent)
		{
			VPTableComponent vptc = (VPTableComponent)o;

			if (!vptc.hasIcon())
			{
				return;
			}
			else
			{
				Point p = new Point(convert(row, col, e.getX(), e.getY()));

				if (vptc.isIconButton(col, p.x, p.y))
				{
					Cell c = new Cell(row, col);
					if (vpTable.hasHighlightedCell())
						vpTable.setHighlightedCell(null);

					if (vpTable.hasSelectedCell())
					{
						if (vpTable.getSelectedCell().equals(c))
							return;
						else
							vpTable.setSelectedCell(c);
					}
					else
					{
						vpTable.setSelectedCell(c);
					}

				}
				else
				{
					if (vpTable.hasHighlightedCell())
						vpTable.setHighlightedCell(null);
					else if (vpTable.hasSelectedCell())
						vpTable.setSelectedCell(null);
					else
						return;
				}
			}
		}
		

	} /**
							 * @param row
							 * @param col
							 * @param i
							 * @param j
							 */
	private Point convert(int row, int col, int i, int j)
	{
		JViewport jv = null;
		Component c = vpTable.getTableViewer().getSelectedComponent();
		if (c instanceof JScrollPane)
		{
			JScrollPane jsp = (JScrollPane)c;
			jv = jsp.getViewport();
		}

		Point pt = jv.getViewPosition();
		Rectangle rect = vpTable.getCellRect(row, col, true);
		Point delta = new Point(i + pt.x, j + pt.y);
		Point conv = new Point(delta.x - rect.x, delta.y - rect.y);
		return conv;
	} /**
								 * @param vpTable
								 * @param row
								 * @param col
								 */
	private void resetOthers(VPTable vpTable, int row, int col)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseListener#mouseEntered(java.awt.event.MouseEvent)
							 */
	public void mouseEntered(MouseEvent e)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseListener#mouseExited(java.awt.event.MouseEvent)
							 */
	public void mouseExited(MouseEvent e)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseListener#mousePressed(java.awt.event.MouseEvent)
							 */
	public void mouseClicked(MouseEvent e)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseListener#mouseReleased(java.awt.event.MouseEvent)
							 */
	public void mouseReleased(MouseEvent e)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseMotionListener#mouseDragged(java.awt.event.MouseEvent)
							 */
	public void mouseDragged(MouseEvent e)
	{} /* (non-Javadoc)
							 * @see java.awt.event.MouseMotionListener#mouseMoved(java.awt.event.MouseEvent)
							 */
	public void mouseMoved(MouseEvent e)
	{
		int row = vpTable.rowAtPoint(new Point(e.getX(), e.getY()));
		int col = vpTable.columnAtPoint(new Point(e.getX(), e.getY()));
		Object o = vpTable.getValueAt(row, col);
		//
		if (o instanceof VPTableComponent)
		{
			VPTableComponent vptc = (VPTableComponent)o;
			if ((!vptc.hasIcon())
				|| ((vpTable.hasSelectedCell()
					&& vpTable.getSelectedCell().equals(new Cell(row, col)))))
				return;
			else
			{
				Point p = new Point(convert(row, col, e.getX(), e.getY()));
				if (vptc.isIconButton(col, p.x, p.y))
				{
					Cell c = new Cell(row, col);
					if ((vpTable.hasHighlightedCell())
						&& (vpTable.getHighlightedCell().equals(c)))
						return;
					else
						vpTable.setHighlightedCell(c);
				}
				else
				{
					if (vpTable.hasHighlightedCell())
						vpTable.setHighlightedCell(null);
					else
						return;
				}
			}
		}
		else
		{
			System.out.println("moved on unrecognized component");
		}
	}
}
