package vp.gui.table.components;

import vp.gui.VPSettings;
import vp.gui.components.VPPanel;
import vp.gui.table.CompoundData;
import vp.gui.table.CompoundTableData;
import vp.gui.table.EdgeData;
import vp.gui.table.EdgeTableData;
import vp.gui.table.VPTable;
import vp.gui.table.VPTableData;

import java.awt.Dimension;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;

public class ArrayCellComponent extends VPPanel implements VPCellComponent
{
	private VPTable vpTable;
	private Object value;
	private int row, column;

	public ArrayCellComponent(JTable table, Object value, int row, int column)
	{
		vpTable = (VPTable)table;
		this.value = value;
		this.row = row;
		this.column = column;
		setLayout(new GridLayout());

		JLabel label = new JLabel("");
		label.setFont(VPSettings.R_FONT);
		label.setOpaque(true);
		//label.setUI(new TableLabelUI());
		label.setBackground(VPSettings.Colors.CLEAR);
		label.setBorder(new EmptyBorder(4, 4, 4, 4));

		if (value instanceof ArrayList)
		{
			ArrayList list = (ArrayList)value;
			if (list.size() == 0)
				add(label);
			else if (list.size() == 1)
			{
				label.setText((String)list.get(0));
				add(label);
			}
			else
			{
				int selectedValue;

				if ((VPTableData)vpTable.getModel()
					instanceof CompoundTableData)
					selectedValue =
						((CompoundData) ((CompoundTableData)vpTable.getModel())
							.getDataVector()
							.elementAt(row))
							.getConnectsValue();
				else if (
					(VPTableData)vpTable.getModel() instanceof EdgeTableData)
					selectedValue =
						((EdgeData) ((EdgeTableData)vpTable.getModel())
							.getDataVector()
							.elementAt(row))
							.getEnzymeValue();
				else
					selectedValue = 0;
				JComboBox jcb = new JComboBox(new Vector(list));
				jcb.setBackground(VPSettings.Colors.CLEAR);
				jcb.setUI(new TableComboBoxUI());

				int colWidth =
					vpTable.getColumnModel().getColumn(column).getWidth();
				jcb.setPreferredSize(
					new Dimension(
						colWidth - 25,
						jcb.getPreferredSize().height));
				jcb.setMinimumSize(
					new Dimension(
						colWidth - 25,
						jcb.getPreferredSize().height));
				jcb.setMaximumSize(
					new Dimension(
						colWidth - 25,
						jcb.getPreferredSize().height));
				jcb.setBorder(new EmptyBorder(0, 4, 0, 0));
				jcb.setFont(VPSettings.R_FONT);
				//jcb.setOpaque(false);
				jcb.setSelectedIndex(selectedValue);
				add(jcb);
			}
		}
		else
			add(new JLabel(""));
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getComponent()
	 */
	public JComponent getComponent()
	{
		return this;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getValue()
	 */
	public Object getValue()
	{
		return value;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getRow()
	 */
	public int getRow()
	{
		return row;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getColumn()
	 */
	public int getColumn()
	{
		return column;
	}
}
