package vp.gui.table.components;

import vp.gui.VPSettings;
import vp.gui.components.VPPanel;
import vp.gui.table.CompoundData;
import vp.gui.table.CompoundTableData;
import vp.gui.table.EdgeData;
import vp.gui.table.EdgeTableData;
import vp.gui.table.VPTable;
import vp.gui.table.VPTableData;

import java.awt.Component;
import java.awt.GridLayout;
import java.util.ArrayList;
import java.util.Vector;
import javax.swing.AbstractCellEditor;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.border.EmptyBorder;
import javax.swing.table.TableCellEditor;

public class ArrayListEditor
	extends AbstractCellEditor
	implements TableCellEditor
{
	private JComponent component, attachment;
	private VPTable vpTable;
	private int row;

	public ArrayListEditor(VPTable vpTable)
	{
		this.vpTable = vpTable;
		component = new VPPanel();
		//component.setBackground(Color.white);
		component.setLayout(new GridLayout());
	}

	public Component getTableCellEditorComponent(
		JTable table,
		Object value,
		boolean isSelected,
		int rowIndex,
		int vColIndex)
	{
		row = rowIndex;
		component.removeAll();
		JLabel label = new JLabel("");
		label.setFont(VPSettings.R_FONT);
		label.setOpaque(true);
		label.setUI(new TableLabelUI());
		//label.setBackground(Color.white);
		label.setBorder(new EmptyBorder(4, 4, 4, 4));

		if (value instanceof ArrayList)
		{

			ArrayList list = (ArrayList)value;
			if (list.size() == 0)
				attachment = label;
			else if (list.size() == 1)
			{
				label.setText((String)list.get(0));
				attachment = label;
			}
			else
			{
				int selectedValue;

				if ((VPTableData)vpTable.getModel()
					instanceof CompoundTableData)
					selectedValue =
						((CompoundData) ((CompoundTableData)vpTable.getModel())
							.getDataVector()
							.elementAt(row))
							.getConnectsValue();
				else if (
					(VPTableData)vpTable.getModel() instanceof EdgeTableData)
					selectedValue =
						((EdgeData) ((EdgeTableData)vpTable.getModel())
							.getDataVector()
							.elementAt(row))
							.getEnzymeValue();
				else
					selectedValue = 0;
				JComboBox jcb = new JComboBox(new Vector(list));
				jcb.setFont(VPSettings.R_FONT);
				jcb.setOpaque(false);
				//jcb.setBackground(Color.white);

				jcb.setSelectedIndex(selectedValue);
				attachment = jcb;
			}
		}
		else
			attachment = label;

		component.add(attachment);
		return component;
	}

	public Object getCellEditorValue()
	{
		if (attachment instanceof JLabel)
			return ((JLabel)attachment).getText();
		else if (attachment instanceof JComboBox)
		{
			int selectedValue = ((JComboBox)attachment).getSelectedIndex();

			if ((VPTableData)vpTable.getModel() instanceof CompoundTableData)
				(
					(CompoundData) ((CompoundTableData)vpTable.getModel())
						.getDataVector()
						.elementAt(row))
						.setConnectsValue(
					selectedValue);

			else if ((VPTableData)vpTable.getModel() instanceof EdgeTableData)
				(
					(EdgeData) ((EdgeTableData)vpTable.getModel())
						.getDataVector()
						.elementAt(
						row)).setEnzymeValue(
					selectedValue);

			return ((JComboBox)attachment).getSelectedItem();
		}
		else
			return null;
	}
}
