package vp.gui.table.components;

import vp.gui.VPSettings;

import javax.swing.JComponent;
import javax.swing.JLabel;
import javax.swing.border.EmptyBorder;

public class PlainCellComponent extends JLabel implements VPCellComponent
{
	private int column;

	private int row;

	private Object value;

	public PlainCellComponent(Object value, int row, int column)
	{
		this.value = value;
		this.row = row;
		this.column = column;
		setBackground(VPSettings.Colors.CLEAR);
		setFont(VPSettings.R_FONT);
		setOpaque(true);
		setBorder(new EmptyBorder(5, 5, 5, 5));
		
		if(value instanceof Number)
			setHorizontalAlignment(JLabel.CENTER);
		setText(value.toString());
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getComponent()
	 */
	public JComponent getComponent()
	{
		return this;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getValue()
	 */
	public Object getValue()
	{
		return value;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getRow()
	 */
	public int getRow()
	{
		return row;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getColumn()
	 */
	public int getColumn()
	{
		return column;
	}
}
