package vp.gui.table.components;

import vp.gui.kunststoff.KunststoffLookAndFeel;
import vp.gui.kunststoff.KunststoffUtilities;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;
import javax.swing.JComponent;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicPanelUI;

public class TablePanelUI extends BasicPanelUI
{
	private static final TablePanelUI PANEL_UI = new TablePanelUI();

	public static ComponentUI createUI(JComponent c)
	{
		return PANEL_UI;
	}

	public void paint(Graphics g, JComponent c)
	{
		super.paint(g, c);
		/*
				if(!c.isOpaque())
					return;
		*/
		Color colorReflection =
			KunststoffLookAndFeel.getComponentGradientColorReflection();
		if (colorReflection != null)
		{
			Color colorReflectionFaded =
				KunststoffUtilities.getTranslucentColor(colorReflection, 0);
			Rectangle rect =
				new Rectangle(0, 0, c.getWidth(), c.getHeight() / 2);
			KunststoffUtilities.drawGradient(
				g,
				colorReflection,
				colorReflectionFaded,
				rect,
				true);
		}

		Color colorShadow =
			KunststoffLookAndFeel.getComponentGradientColorShadow();
		if (colorShadow != null)
		{
			Color colorShadowFaded =
				KunststoffUtilities.getTranslucentColor(colorShadow, 0);
			Rectangle rect =
				new Rectangle(
					0,
					c.getHeight() / 2,
					c.getWidth(),
					c.getHeight() / 2);
			KunststoffUtilities.drawGradient(
				g,
				colorShadowFaded,
				colorShadow,
				rect,
				true);
		}
	}
}
