package vp.gui.table.components;

import vp.graph.PathwayGraph;
import vp.gui.VPSettings;
import vp.gui.table.*;
import vp.main.MainFrame;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JViewport;

public class TableViewer extends JTabbedPane
{
	private JTable compoundTable;
	private JTable edgeTable;
	private JTable enzymeTable;
	private JScrollPane compoundTableScroller;
	private JScrollPane edgeTableScroller;
	private JScrollPane enzymeTableScroller;
	private Listener listener;
	private MainFrame parent;

	public TableViewer(MainFrame parent, PathwayGraph pGraph)
	{
		this.parent = parent;
		compoundTable = new CompoundTable(this, pGraph);
		edgeTable = new EdgeTable(this, pGraph);
		enzymeTable = new EnzymeTable(this, pGraph);
		listener = new Listener();
		Dimension scrollSize = parent.getSize();

		compoundTableScroller =
			new JScrollPane(
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		compoundTableScroller.setBackground(Color.LIGHT_GRAY);
		JViewport compoundTableView = new JViewport();
		compoundTableView.setPreferredSize(scrollSize);
        compoundTableView.setBackground(Color.LIGHT_GRAY);
		compoundTableView.setView(compoundTable);
		compoundTableScroller.setViewport(compoundTableView);

		edgeTableScroller =
			new JScrollPane(
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		JViewport edgeTableView = new JViewport();
		edgeTableView.setPreferredSize(scrollSize);
		edgeTableView.setView(edgeTable);
		edgeTableScroller.setViewport(edgeTableView);

		enzymeTableScroller =
			new JScrollPane(
				JScrollPane.VERTICAL_SCROLLBAR_AS_NEEDED,
				JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		JViewport enzymeTableView = new JViewport();
		enzymeTableView.setPreferredSize(scrollSize);
		enzymeTableView.setView(enzymeTable);
		enzymeTableScroller.setViewport(enzymeTableView);

		setFont(VPSettings.B_FONT);
		addTab("Compounds", compoundTableScroller);
		addTab("Edges", edgeTableScroller);
		addTab("Enzymes", enzymeTableScroller);
	}

	public Listener getListener()
	{
		return listener;
	}

	private class Listener implements ActionListener
	{
		public void actionPerformed(ActionEvent event)
		{
			String command = event.getActionCommand();

			
		}
	}
	/**
	 * @return
	 */
	public MainFrame getMainFrame()
	{
		return parent;
	}

	/**
	 * @param frame
	 */
	public void setMainFrame(MainFrame frame)
	{
		parent = frame;
	}

}
