package vp.gui.table.components;

import vp.gui.components.VPPanel;
import vp.gui.table.CompoundTable;
import vp.gui.table.EdgeTable;
import vp.gui.table.EdgeTableData;
import vp.gui.table.EnzymeTable;
import vp.gui.table.VPTable;
import vp.visual.Renderer;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.JComponent;
import javax.swing.JTable;

public class TypeCellComponent extends VPPanel implements VPCellComponent
{
	private int column;
	private int row;
	private Object value;
	VPTable vptable;
	PreviewLabel pl;

	public TypeCellComponent(JTable table, Object value, int row, int column)
	{
		this.value = value;
		this.row = row;
		this.column = column;
		vptable = (VPTable)table;
		//setOpaque(true);
		setLayout(new GridLayout());
		//setUI(new TablePanelUI());
		if (table instanceof CompoundTable)
			pl =
				new PreviewLabel(
					vptable.getMainFrame(),
					(Renderer)value,
					new Dimension(
						VPTable.TYPE_WIDTH - 2,
						VPTable.ROW_HEIGHT - 2));
		else if (table instanceof EdgeTable)
		{
			EdgeTableData eData =
				(EdgeTableData) ((EdgeTable)vptable).getModel();
			pl =
				new PreviewLabel(
					vptable.getMainFrame(),
					(Renderer)value,
					new Dimension(
						VPTable.TYPE_WIDTH - 2,
						VPTable.ROW_HEIGHT - 2));
		}
		else if (table instanceof EnzymeTable)
			pl =
				new PreviewLabel(
					vptable.getMainFrame(),
					(Renderer)value,
					new Dimension(
						VPTable.TYPE_WIDTH - 2,
						VPTable.ROW_HEIGHT - 2));
		add(pl);
	}
	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getComponent()
	 */
	public JComponent getComponent()
	{
		return this;
	}
	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getValue()
	 */
	public Object getValue()
	{
		return value;
	}
	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getRow()
	 */
	public int getRow()
	{
		return row;
	}
	/* (non-Javadoc)
	 * @see vp.src.edu.yale.vitapad.gui.table.VPCellComponent#getColumn()
	 */
	public int getColumn()
	{
		return column;
	}
}
