package vp.gui.table.components;

import java.awt.Color;
import java.awt.Component;
import java.awt.GridLayout;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.TableCellRenderer;

import vp.gui.VPSettings;
import vp.gui.table.VPTable;

public class VPCellRenderer extends JLabel implements TableCellRenderer
{
	private VPTableComponent vptc;

	private VPTableComponent newVptc = null;

	private int rRow, rCol;
	private final Color bluish = VPSettings.Colors.LM_BLUE;
	private final Color highlight = VPSettings.Colors.SKY_BLUE;

	public Component getTableCellRendererComponent(
		JTable table,
		Object value,
		boolean isSelected,
		boolean hasFocus,
		int row,
		int column)
	{
		if (value instanceof VPTableComponent)
		{
			vptc = (VPTableComponent)value;
			if ((((VPTable)table).hasSelectedCell())
				&& (row == ((VPTable)table).getSelectedCell().row))
			{
				vptc.setBackground(highlight);

				if (column == 0)
					vptc.setSelectedBorder(true, true, true, false);
				else if (column == table.getColumnCount() - 1)
					vptc.setSelectedBorder(true, false, true, true);
				else
					vptc.setSelectedBorder(true, false, true, false);
			}
			else
				vptc.setSelectedBorder(false, false, false, false);

			if (((((VPTable)table).hasHighlightedCell())
				&& (row == ((VPTable)table).getHighlightedCell().row))
				|| (((VPTable)table).hasSelectedCell())
				&& (row == ((VPTable)table).getSelectedCell().row))
				vptc.setBackground(highlight);
			else if (row % 2 == 0)
				vptc.setBackground(Color.white);
			else
				vptc.setBackground(bluish);
			if (newVptc != null)
			{
				if (row == newVptc.getRow())
				{
					newVptc.setBackground(highlight);
					if ((((VPTable)table).hasSelectedCell())
						&& (((VPTable)table).getSelectedCell().row == row))
					{
						if (column == 0)
							newVptc.setSelectedBorder(true, true, true, false);
						else
							newVptc.setSelectedBorder(true, false, true, false);
					}

					if (column == newVptc.getColumn())
						specialRender();
					else
					{
						regularRender();
					}
				}
				else
				{
					regularRender();
				}
			}
			else
				regularRender();
		}
		return this;
	}

	public void render(VPTableComponent newVptc)
	{
		this.newVptc = newVptc;
	}

	public void specialRender()
	{
		removeAll();
		setLayout(new GridLayout(1, 1));
		add(newVptc);
		//repaint();
	}

	public void regularRender()
	{
		removeAll();
		setLayout(new GridLayout(1, 1));
		add(vptc);
	}

	/* (non-Javadoc)
	 * @see java.awt.Component#firePropertyChange(java.lang.String, boolean, boolean)
	 */
	public void firePropertyChange(
		String propertyName,
		boolean oldValue,
		boolean newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, byte, byte)
	 */
	public void firePropertyChange(
		String propertyName,
		byte oldValue,
		byte newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, char, char)
	 */
	public void firePropertyChange(
		String propertyName,
		char oldValue,
		char newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, double, double)
	 */
	public void firePropertyChange(
		String propertyName,
		double oldValue,
		double newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, float, float)
	 */
	public void firePropertyChange(
		String propertyName,
		float oldValue,
		float newValue)
	{}

	/* (non-Javadoc)
	 * @see java.awt.Component#firePropertyChange(java.lang.String, int, int)
	 */
	public void firePropertyChange(
		String propertyName,
		int oldValue,
		int newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, long, long)
	 */
	public void firePropertyChange(
		String propertyName,
		long oldValue,
		long newValue)
	{}

	/* (non-Javadoc)
	 * @see java.awt.Component#firePropertyChange(java.lang.String, java.lang.Object, java.lang.Object)
	 */
	protected void firePropertyChange(
		String propertyName,
		Object oldValue,
		Object newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#firePropertyChange(java.lang.String, short, short)
	 */
	public void firePropertyChange(
		String propertyName,
		short oldValue,
		short newValue)
	{}

	/* (non-Javadoc)
	 * @see javax.swing.JComponent#revalidate()
	 */
	public void revalidate()
	{}

	/* (non-Javadoc)
	 * @see java.awt.Component#validate()
	 */
	public void validate()
	{
		super.validate();
	}

	/* (non-Javadoc)
	 * @see java.awt.Component#repaint()
	 */
	public void repaint()
	{}

	/* (non-Javadoc)
	 * @see java.awt.Component#repaint(int, int, int, int)
	 */
	public void repaint(int x, int y, int width, int height)
	{}

	/* (non-Javadoc)
	 * @see java.awt.Component#repaint(long)
	 */
	public void repaint(long tm)
	{}

}
