package vp.gui.table.components;

import vp.util.IconFactory;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.border.EtchedBorder;

public class VPTableButton extends JLabel
{
	private ImageIcon onIcon;
	private ImageIcon offIcon;
	private ImageIcon rollIcon;
	public static final int ASCENDING = 0;
	public static final int DESCENDING = 1;
	public static final int LOOKUP = 2;
	public static final int EDIT = 3;
	public static final int GOTO = 4;

	public VPTableButton(int type)
	{
		switch (type)
		{
		case ASCENDING:
			onIcon = new ImageIcon(IconFactory.getSelectedUpSortIcon());
			offIcon = new ImageIcon(IconFactory.getUpSortIcon());
			rollIcon = new ImageIcon(IconFactory.getRolloverUpSortIcon());
			break;
		case DESCENDING:
			onIcon = new ImageIcon(IconFactory.getSelectedDownSortIcon());
			offIcon = new ImageIcon(IconFactory.getDownSortIcon());
			rollIcon = new ImageIcon(IconFactory.getRolloverDownSortIcon());
			break;
		case LOOKUP:
			onIcon = new ImageIcon(IconFactory.getSelectedLookupIcon());
			offIcon = new ImageIcon(IconFactory.getLookupIcon());
			rollIcon = new ImageIcon(IconFactory.getRolloverLookupIcon());
			setBorder(new EtchedBorder());
			break;
		case EDIT:
			onIcon = new ImageIcon(IconFactory.getSelectedSmallEditIcon());
			offIcon = new ImageIcon(IconFactory.getSmallEditIcon());
			rollIcon = new ImageIcon(IconFactory.getRolloverSmallEditIcon());
			setBorder(new EtchedBorder());
			break;
		case GOTO:
			onIcon = new ImageIcon(IconFactory.getSelectedGotoIcon());
			offIcon = new ImageIcon(IconFactory.getGotoIcon());
			rollIcon = new ImageIcon(IconFactory.getRolloverGotoIcon());
			setBorder(new EtchedBorder());
			break;
		}
		setIcon(offIcon);
	}

	public void setRollover()
	{
		setIcon(rollIcon);
	}

	public void setSelected()
	{
		setIcon(onIcon);
	}

	public void setOff()
	{
		setIcon(offIcon);
	}
}
