/*
 * Created on Mar 10, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.main;

import java.awt.Point;
import java.awt.Rectangle;
import java.io.File;
import java.text.NumberFormat;
import java.util.ListIterator;

import vp.graph.PathwayGraph;
import vp.graph.PathwayVertex;
import vp.util.xml.XMLToGraph;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class MovementDemo
{

	private NumberFormat nf;
	private PathwayVertex nh3;
	private PathwayGraph pGraph;
	private MainFrame mainFrame;
	private int snapCount;

	public MovementDemo(MainFrame mainFrame)
	{
		File selectedFile =
			new File("c:\\eclipse\\workspace\\vitapad\\etc\\files\\test.xml");
		this.mainFrame = mainFrame;
		pGraph = mainFrame.getPathwayGraph();
		snapCount = 0;
		nf = NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(3);
		mainFrame.showNewGraph();
		PathwayGraph xmltg = XMLToGraph.loadXMLFile(pGraph, selectedFile);

		try
		{
			mainFrame.showGraph(xmltg);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

		/*
		 * Get the vertex.
		 */
		ListIterator iter = pGraph.getVertexIterator();
		while (iter.hasNext())
		{
			PathwayVertex pv = (PathwayVertex)iter.next();
			if (pv.getDataClass().get("Name").equals("NH3"))
			{
				nh3 = pv;
				break;
			}
		}
		Point a = new Point(331, 320);
		Point b = new Point(339, 173);
		Point c = new Point(466, 311);
		Point d = new Point(352, 461);
		Point e = new Point(208, 313);
		moveTo(a, b);
		moveTo(b, a);
		moveTo(a, c);
		moveTo(c, a);
		moveTo(a, d);
		moveTo(d, a);
		moveTo(a, e);
		moveTo(e, a);

	}
	/**
	 * @param point
	 * @param point2
	 */
	private void moveTo(Point point, Point point2)
	{
		int spacing = 10;
		float xSpan = Math.max(point.x, point2.x) - Math.min(point.x, point2.x);
		float ySpan = Math.max(point.y, point2.y) - Math.min(point.y, point2.y);
		float span = Math.max(xSpan, ySpan);
		float xRun = point2.x - point.x;
		float yRun = point2.y - point.y;
		float xMove = (xRun / span) * spacing;
		float yMove = (yRun / span) * spacing;

		for (int i = 0; i < span / spacing; i++)
		{
			float newX = point.x + (int) (xMove * i);
			float newY = point.y + (int) (yMove * i);
			nh3.setLocation(newX, newY);
			pGraph.repaint();
			try
			{
				Thread.sleep(500);
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
			snap();
		}
		nh3.setLocation(point2.x, point2.y);
		pGraph.repaint();

		try
		{
			Thread.sleep(500);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		snap();
	}
	/**
	 * 
	 */
	private void snap()
	{
		File file =
			new File(
				"c:\\eclipse\\workspace\\vitapad\\etc\\files\\clip"
					+ nf.format(snapCount)
					+ ".png");
		Rectangle rect = new Rectangle(150, 150, 400, 400);
		mainFrame.captureScreenClip(rect, file);
		snapCount++;
	}

}
