package vp.main;

import vp.gui.VPSettings;
import vp.gui.components.VPButton;
import vp.gui.components.VPPanel;
import vp.util.ActionCenter;
import vp.util.SwingWorker;
import vp.visual.type.Type;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.ImageIcon;
import javax.swing.JPanel;
import javax.swing.Timer;
import javax.swing.border.LineBorder;

public class OpeningScreen extends VPPanel
{
    private MainFrame parent;

    private Type vertType, edgeType;

    private OpeningScreen thisScreen;

    private int alphaCount;

    public OpeningScreen(MainFrame parent)
    {
        this.parent = parent;
        thisScreen = this;
        alphaCount = 0;
        Listener listener = new Listener();
        final VPImageCanvas vpiCanvas = new VPImageCanvas();
        setLayout(new GridBagLayout());
        GridBagConstraints superc = new GridBagConstraints();
        superc.gridwidth = 2;
        add(vpiCanvas, superc);

        superc.gridy = 1;
        superc.fill = GridBagConstraints.BOTH;
        VPPanel choicePanel = new VPPanel();
        choicePanel.setLayout(new GridBagLayout());
        choicePanel.setBackground(VPSettings.Colors.BEIGE);
        GridBagConstraints choicec = new GridBagConstraints();
        choicec.insets = new Insets(10, 10, 10, 10);
        choicePanel.add(new VPButton("Create new pathway",
            ActionCenter.NEW, listener), choicec);
        choicePanel.add(new VPButton("Load existing pathway",
            ActionCenter.LOAD_FILE, listener), choicec);
        choicePanel.setBorder(new LineBorder(
            VPSettings.Colors.D_BLUE, 2));

        add(choicePanel, superc);

        setLocation(
            (parent.getBounds().x + (parent.getBounds().width / 2))
                - (getBounds().width / 2),
            (parent.getBounds().y + (parent.getBounds().height / 2))
                - (getBounds().height / 2));
        parent.getContentPane().add(this);
        SwingWorker sw = new SwingWorker()
        {
            private Timer timer;

            /*
             * (non-Javadoc)
             * 
             * @see vp.src.edu.yale.vitapad.util.SwingWorker#construct()
             */
            public Object construct()
            {
                ActionListener listener = new ActionListener()
                {

                    public void actionPerformed(ActionEvent e)
                    {
                        vpiCanvas.repaint();
                        alphaCount++;
                    }
                };

                timer = new Timer(15, listener);
                timer.start();
                try
                {
                    Thread.sleep(2000);
                }
                catch (InterruptedException e1)
                {
                    e1.printStackTrace();
                }
                return null;
            }

            /*
             * (non-Javadoc)
             * 
             * @see vp.src.edu.yale.vitapad.util.SwingWorker#finished()
             */
            public void finished()
            {
                timer.stop();
            }

        };
        sw.start();

    }

    class VPImageCanvas extends JPanel
    {

        protected Timer timer;

        VPImageCanvas()
        {
            setPreferredSize(new Dimension(394, 181));
        }

        public void paint(final Graphics g)
        {
            ImageIcon icon = new ImageIcon("logo.png");
            g.drawImage(icon.getImage(), 0, 0, this);
            alphaCount = (alphaCount <= 80) ? alphaCount : 80;
            g.setColor(new Color(255, 255, 255,
                240 - (alphaCount * 3)));
            g.fillRect(0, 0, 394, 181);

        }
    }

    private class Listener implements ActionListener
    {
        public void actionPerformed(ActionEvent event)
        {
            String command = event.getActionCommand();
            if (command.equals(ActionCenter.NEW))
            {
                parent.remove(thisScreen);
                parent.onNew();

            }
            else if (command.equals(ActionCenter.LOAD_FILE))
            {
                parent.remove(thisScreen);
                parent.onLoadFile();

            }
        }
    }
}
