package vp.main;

import java.awt.AWTException;
import java.awt.Point;
import java.awt.Robot;
import java.awt.event.InputEvent;

public class VPDemo
{
	private Robot robot;
	private Point[] points = 
	{
		new Point(300, 300),
		new ClickPoint(12, 37),
		new ClickPoint(16, 93),
		new ClickPoint(169, 226), 
		new ClickPoint(684, 443),
		new ClickPoint(74, 70),
		new PressPoint(345, 153),
		new Point(488, 157),
		new Point(482, 112),
		new Point(293, 126),
		new ReleasePoint(352, 152)
	};

	public VPDemo()
	{
		try
		{
			runRobot();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

	private void runRobot() throws AWTException
	{
		robot = new Robot();
		robot.mouseMove(300, 300);

		for (int i = 1;i < points.length ;i++ )
		{
			moveRobot(points[i-1], points[i]);
			if(points[i] instanceof ClickPoint)
			{
				robot.mousePress(InputEvent.BUTTON1_MASK);
				robot.delay(500);
				robot.mouseRelease(InputEvent.BUTTON1_MASK);
			}
			else if(points[i] instanceof ReleasePoint)
				robot.mouseRelease(InputEvent.BUTTON1_MASK);
			else if(points[i] instanceof PressPoint)
				robot.mousePress(InputEvent.BUTTON1_MASK);
		}
	}

	private void moveRobot(Point oldP, Point newP)
	{
		float xSpan = Math.max(oldP.x, newP.x) - Math.min(oldP.x, newP.x);
		float ySpan = Math.max(oldP.y, newP.y) - Math.min(oldP.y, newP.y);
		float span = Math.max(xSpan, ySpan);

		float xRun = newP.x - oldP.x;
		float yRun = newP.y - oldP.y;
		float xMove = xRun/span;
		float yMove = yRun/span;

		for (int i = 0;i < span ;i++ )
		{
			robot.delay(5);
			
			float newX = oldP.x + (int)(xMove * i);
			float newY = oldP.y + (int)(yMove * i);
			robot.mouseMove((int)newX, (int)newY);
		}
	}

	private class ClickPoint extends Point
	{
		public ClickPoint(int x, int y)
		{
			super(x, y);
		}
	}

	private class ReleasePoint extends Point
	{
		public ReleasePoint(int x, int y)
		{
			super(x, y);
		}
	}

	private class PressPoint extends Point
	{
		public PressPoint(int x, int y)
		{
			super(x, y);
		}
	}
}
