package vp.util;

import java.util.EventObject;

import vp.main.GraphPanelMode;

/**
* An event object encapsulating a request to change the graph panel setting from one UI mode to another.
*/
public class ChangeModeEvent extends EventObject
{
	private GraphPanelMode requestedMode;

	/**
	* Constructs an event object with the specified information.
	*
	* @param source	The object making the request.  This will invariably be the <code>GraphPanel</code>.
	* @param requestedMode	The new UI mode desired.
	*/
	public ChangeModeEvent(Object source, GraphPanelMode requestedMode) 
	{
		super(source);
		this.requestedMode = requestedMode;
	}

	/**
	* Returns the mode the event is requesting.
	*/
	public GraphPanelMode getRequestedMode() 
	{
		return requestedMode;
	}
}
