package vp.util;

import java.util.Vector;

public class DataSet
{
	private Vector data;
	private String pathID;

	public DataSet()
	{
		data = new Vector();
	}

	public String getPathID()
	{
		return pathID;
	}

	public DataEntry getEntry(int index)
	{
		return (DataEntry)data.elementAt(index);
	}

	public String getEnzyme(int index)
	{
		return ((DataEntry)data.elementAt(index)).getEnzyme();
	}

	public String getCompound(int index)
	{
		return ((DataEntry)data.elementAt(index)).getCompound();
	}

	public String getECNumber(int index)
	{
		return ((DataEntry)data.elementAt(index)).getECNumber();
	}

	public String getDirection(int index)
	{
		return ((DataEntry)data.elementAt(index)).getDirection();
	}

	public int getXPosition(int index)
	{
		try
		{
			return Integer.parseInt(
				((DataEntry)data.elementAt(index)).getXPosition());
		}
		catch (Exception ne)
		{
			return -1;
		}
	}

	public int getYPosition(int index)
	{
		try
		{
			return Integer.parseInt(
				((DataEntry)data.elementAt(index)).getYPosition());
		}
		catch (Exception ne)
		{
			return -1;
		}
	}

	public int getToElement(int index)
	{
		try
		{
			return Integer.parseInt(
				((DataEntry)data.elementAt(index)).getToElement());
		}
		catch (Exception ne)
		{
			return -1;
		}
	}

	public String getToLink(int index)
	{
		return ((DataEntry)data.elementAt(index)).getToLink();
	}

	public String getAddFrom(int index)
	{
		return ((DataEntry)data.elementAt(index)).getAddFrom();

	}

	public String getAddTo(int index)
	{
		return ((DataEntry)data.elementAt(index)).getAddTo();

	}

	public String getExpression(int index)
	{
		try
		{
			String exp = ((DataEntry)data.elementAt(index)).getExpression();
			int l = Math.min(exp.length(), 5);
			return exp.substring(0, l);
		}
		catch (Exception e)
		{
			return "N/A";
		}
	}

	public String getDirectLink(int index)
	{
		return ((DataEntry)data.elementAt(index)).getDirectLink();
	}

	public String getDirectLinkType(int index)
	{
		return ((DataEntry)data.elementAt(index)).getDirectLinkType();
	}

	public String getECURL(int index)
	{
		return "http://130.132.76.53/path_ec_click.jsp?path="
			+ pathID
			+ "&ec="
			+ getECNumber(index);
	}

	public int getSize()
	{
		return data.size();
	}

	public void add(DataEntry de)
	{
		data.addElement(de);
	}

	public void clear()
	{
		data.removeAllElements();
	}

	public int getMultiple(int index)
	{
		int mult = 1;
		if (index >= 1)
		{
			while (getCompound(index).equals(getCompound(index - 1))
				&& getToElement(index) == getToElement(index - 1)
				&& index >= 1)
			{
				mult++;
				index--;
			}
		}
		return mult;
	}
}
