package vp.util;

import vp.gui.VPSettings;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.awt.geom.AffineTransform;
import java.awt.geom.Arc2D;
import java.awt.geom.CubicCurve2D;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.image.BufferedImage;

public class IconFactory
{

	private static BufferedImage disabledEnzymeIcon;
	private static BufferedImage disabledGeneIcon;
	private static BufferedImage selectedExperimentIcon;
	private static BufferedImage rolloverExperimentIcon;
	private static BufferedImage experimentIcon;
	private static BufferedImage selectedEnzymeIcon;
	private static BufferedImage rolloverEnzymeIcon;
	private static BufferedImage enzymeIcon;
	private static BufferedImage disabledRedoIcon;
	private static BufferedImage vpIcon;
	private static BufferedImage arrowIcon;
	private static BufferedImage selectedArrowIcon;
	private static BufferedImage rolloverArrowIcon;
	private static BufferedImage lockIcon;
	private static BufferedImage selectedLockIcon;
	private static BufferedImage rolloverLockIcon;
	private static BufferedImage pencilIcon;
	private static BufferedImage selectedPencilIcon;
	private static BufferedImage rolloverPencilIcon;
	private static BufferedImage edgeIcon;
	private static BufferedImage selectedEdgeIcon;
	private static BufferedImage rolloverEdgeIcon;
	private static BufferedImage moveIcon;
	private static BufferedImage selectedMoveIcon;
	private static BufferedImage rolloverMoveIcon;
	private static BufferedImage editIcon;
	private static BufferedImage selectedEditIcon;
	private static BufferedImage rolloverEditIcon;
	private static BufferedImage smallEditIcon;
	private static BufferedImage selectedSmallEditIcon;
	private static BufferedImage rolloverSmallEditIcon;
	private static BufferedImage deleteIcon;
	private static BufferedImage selectedDeleteIcon;
	private static BufferedImage rolloverDeleteIcon;
	private static BufferedImage undoIcon;
	private static BufferedImage selectedUndoIcon;
	private static BufferedImage rolloverUndoIcon;
	private static BufferedImage disabledUndoIcon;
	private static BufferedImage redoIcon;
	private static BufferedImage selectedRedoIcon;
	private static BufferedImage rolloverRedoIcon;
	private static BufferedImage zoomInIcon;
	private static BufferedImage selectedZoomInIcon;
	private static BufferedImage rolloverZoomInIcon;
	private static BufferedImage zoomOutIcon;
	private static BufferedImage selectedZoomOutIcon;
	private static BufferedImage rolloverZoomOutIcon;
	private static BufferedImage imageIcon;
	private static BufferedImage selectedImageIcon;
	private static BufferedImage nameIcon;
	private static BufferedImage selectedNameIcon;
	private static BufferedImage errorIcon;
	private static BufferedImage saveIcon;
	private static BufferedImage newIcon;
	private static BufferedImage upSortIcon;
	private static BufferedImage selectedUpSortIcon;
	private static BufferedImage rolloverUpSortIcon;
	private static BufferedImage downSortIcon;
	private static BufferedImage selectedDownSortIcon;
	private static BufferedImage rolloverDownSortIcon;
	private static BufferedImage lookupIcon;
	private static BufferedImage selectedLookupIcon;
	private static BufferedImage rolloverLookupIcon;
	private static BufferedImage gotoIcon;
	private static BufferedImage selectedGotoIcon;
	private static BufferedImage rolloverGotoIcon;
	private static BufferedImage geneIcon;
	private static BufferedImage selectedGeneIcon;
	private static BufferedImage rolloverGeneIcon;
	private static Color DISABLED_COLOR = Color.LIGHT_GRAY;
	private static final Color ON_COLOR = VPSettings.Colors.M_RED;
	private static final Color OFF_COLOR = Color.black;
	private static final Color ROLL_COLOR = VPSettings.Colors.MD_BLUE;

	private IconFactory()
	{}

	public static BufferedImage getVPIcon()
	{
		if (vpIcon == null)
			createVPIcon();
		return vpIcon;
	}

	public static BufferedImage getNewIcon()
	{
		if (newIcon == null)
			newIcon = createNewIcon(OFF_COLOR);
		return newIcon;
	}

	public static BufferedImage getErrorIcon()
	{
		if (errorIcon == null)
			errorIcon = createErrorIcon(OFF_COLOR);
		return errorIcon;
	}

	public static BufferedImage getSaveIcon()
	{
		if (saveIcon == null)
			saveIcon = createSaveIcon(OFF_COLOR);
		return saveIcon;
	}

	public static BufferedImage getArrowIcon()
	{
		if (arrowIcon == null)
			arrowIcon = createArrowIcon(OFF_COLOR);
		return arrowIcon;
	}

	public static BufferedImage getSelectedArrowIcon()
	{
		if (selectedArrowIcon == null)
			selectedArrowIcon = createArrowIcon(ON_COLOR);
		return selectedArrowIcon;
	}

	public static BufferedImage getRolloverArrowIcon()
	{
		if (rolloverArrowIcon == null)
			rolloverArrowIcon = createArrowIcon(ROLL_COLOR);
		return rolloverArrowIcon;
	}

	public static BufferedImage getLockIcon()
	{
		if (lockIcon == null)
			lockIcon = createLockIcon(OFF_COLOR);
		return lockIcon;
	}

	public static BufferedImage getSelectedLockIcon()
	{
		if (selectedLockIcon == null)
			selectedLockIcon = createLockIcon(ON_COLOR);
		return selectedLockIcon;
	}

	public static BufferedImage getRolloverLockIcon()
	{
		if (rolloverLockIcon == null)
			rolloverLockIcon = createLockIcon(ROLL_COLOR);
		return rolloverLockIcon;
	}

	public static BufferedImage getPencilIcon()
	{
		if (pencilIcon == null)
			pencilIcon = createPencilIcon(OFF_COLOR);
		return pencilIcon;
	}

	public static BufferedImage getSelectedPencilIcon()
	{
		if (selectedPencilIcon == null)
			selectedPencilIcon = createPencilIcon(ON_COLOR);
		return selectedPencilIcon;
	}

	public static BufferedImage getRolloverPencilIcon()
	{
		if (rolloverPencilIcon == null)
			rolloverPencilIcon = createPencilIcon(ROLL_COLOR);
		return rolloverPencilIcon;
	}

	public static BufferedImage getEdgeIcon()
	{
		if (edgeIcon == null)
			edgeIcon = createEdgeIcon(OFF_COLOR);
		return edgeIcon;
	}

	public static BufferedImage getSelectedEdgeIcon()
	{
		if (selectedEdgeIcon == null)
			selectedEdgeIcon = createEdgeIcon(ON_COLOR);
		return selectedEdgeIcon;
	}

	public static BufferedImage getRolloverEdgeIcon()
	{
		if (rolloverEdgeIcon == null)
			rolloverEdgeIcon = createEdgeIcon(ROLL_COLOR);
		return rolloverEdgeIcon;
	}

	public static BufferedImage getMoveIcon()
	{
		if (moveIcon == null)
			moveIcon = createMoveIcon(OFF_COLOR);
		return moveIcon;
	}

	public static BufferedImage getSelectedMoveIcon()
	{
		if (selectedMoveIcon == null)
			selectedMoveIcon = createMoveIcon(ON_COLOR);
		return selectedMoveIcon;
	}

	public static BufferedImage getRolloverMoveIcon()
	{
		if (rolloverMoveIcon == null)
			rolloverMoveIcon = createMoveIcon(ROLL_COLOR);
		return rolloverMoveIcon;
	}

	public static BufferedImage getEditIcon()
	{
		if (editIcon == null)
			editIcon = createEditIcon(OFF_COLOR);
		return editIcon;
	}

	public static BufferedImage getSelectedEditIcon()
	{
		if (selectedEditIcon == null)
			selectedEditIcon = createEditIcon(ON_COLOR);
		return selectedEditIcon;
	}

	public static BufferedImage getRolloverEditIcon()
	{
		if (rolloverEditIcon == null)
			rolloverEditIcon = createEditIcon(ROLL_COLOR);
		return rolloverEditIcon;
	}

	public static BufferedImage getSmallEditIcon()
	{
		if (smallEditIcon == null)
			smallEditIcon = createSmallEditIcon(OFF_COLOR);
		return smallEditIcon;
	}

	public static BufferedImage getSelectedSmallEditIcon()
	{
		if (selectedSmallEditIcon == null)
			selectedSmallEditIcon = createSmallEditIcon(ON_COLOR);
		return selectedSmallEditIcon;
	}

	public static BufferedImage getRolloverSmallEditIcon()
	{
		if (rolloverSmallEditIcon == null)
			rolloverSmallEditIcon = createSmallEditIcon(ROLL_COLOR);
		return rolloverSmallEditIcon;
	}

	public static BufferedImage getDeleteIcon()
	{
		if (deleteIcon == null)
			deleteIcon = createDeleteIcon(OFF_COLOR);
		return deleteIcon;
	}

	public static BufferedImage getSelectedDeleteIcon()
	{
		if (selectedDeleteIcon == null)
			selectedDeleteIcon = createDeleteIcon(ON_COLOR);
		return selectedDeleteIcon;
	}

	public static BufferedImage getRolloverDeleteIcon()
	{
		if (rolloverDeleteIcon == null)
			rolloverDeleteIcon = createDeleteIcon(ROLL_COLOR);
		return rolloverDeleteIcon;
	}

	public static BufferedImage getUndoIcon()
	{
		if (undoIcon == null)
			undoIcon = createUndoIcon(OFF_COLOR);
		return undoIcon;
	}

	public static BufferedImage getSelectedUndoIcon()
	{
		if (selectedUndoIcon == null)
			selectedUndoIcon = createUndoIcon(ON_COLOR);
		return selectedUndoIcon;
	}

	public static BufferedImage getRolloverUndoIcon()
	{
		if (rolloverUndoIcon == null)
			rolloverUndoIcon = createUndoIcon(ROLL_COLOR);
		return rolloverUndoIcon;
	}

	/**
	 * @return
	 */
	public static BufferedImage getDisabledUndoIcon()
	{
		if (disabledUndoIcon == null)
			disabledUndoIcon = createUndoIcon(DISABLED_COLOR);
		return disabledUndoIcon;
	}

	public static BufferedImage getRedoIcon()
	{
		if (redoIcon == null)
			redoIcon = createRedoIcon(OFF_COLOR);
		return redoIcon;
	}

	public static BufferedImage getSelectedRedoIcon()
	{
		if (selectedRedoIcon == null)
			selectedRedoIcon = createRedoIcon(ON_COLOR);
		return selectedRedoIcon;
	}

	public static BufferedImage getRolloverRedoIcon()
	{
		if (rolloverRedoIcon == null)
			rolloverRedoIcon = createRedoIcon(ROLL_COLOR);
		return rolloverRedoIcon;
	}

	public static BufferedImage getDisabledRedoIcon()
	{
		if (disabledRedoIcon == null)
			disabledRedoIcon = createRedoIcon(DISABLED_COLOR);
		return disabledRedoIcon;
	}

	public static BufferedImage getDisabledGeneIcon()
	{
		if (disabledGeneIcon == null)
			disabledGeneIcon = createGeneIcon(DISABLED_COLOR);
		return disabledGeneIcon;
	}

	public static BufferedImage getDisabledEnzymeIcon()
	{
		if (disabledEnzymeIcon == null)
			disabledEnzymeIcon = createEnzymeIcon(DISABLED_COLOR);
		return disabledEnzymeIcon;
	}

	public static BufferedImage getZoomInIcon()
	{
		if (zoomInIcon == null)
			zoomInIcon = createZoomInIcon(OFF_COLOR);
		return zoomInIcon;
	}

	public static BufferedImage getSelectedZoomInIcon()
	{
		if (selectedZoomInIcon == null)
			selectedZoomInIcon = createZoomInIcon(ON_COLOR);
		return selectedZoomInIcon;
	}

	public static BufferedImage getRolloverZoomInIcon()
	{
		if (rolloverZoomInIcon == null)
			rolloverZoomInIcon = createZoomInIcon(ROLL_COLOR);
		return rolloverZoomInIcon;
	}

	public static BufferedImage getZoomOutIcon()
	{
		if (zoomOutIcon == null)
			zoomOutIcon = createZoomOutIcon(OFF_COLOR);
		return zoomOutIcon;
	}

	public static BufferedImage getSelectedZoomOutIcon()
	{
		if (selectedZoomOutIcon == null)
			selectedZoomOutIcon = createZoomOutIcon(ON_COLOR);
		return selectedZoomOutIcon;
	}

	public static BufferedImage getRolloverZoomOutIcon()
	{
		if (rolloverZoomOutIcon == null)
			rolloverZoomOutIcon = createZoomOutIcon(ROLL_COLOR);
		return rolloverZoomOutIcon;
	}

	public static BufferedImage getImageIcon()
	{
		if (imageIcon == null)
			imageIcon = createImageIcon(OFF_COLOR);
		return imageIcon;
	}

	public static BufferedImage getSelectedImageIcon()
	{
		if (selectedImageIcon == null)
			selectedImageIcon = createImageIcon(ON_COLOR);
		return selectedImageIcon;
	}

	public static BufferedImage getNameIcon()
	{
		if (nameIcon == null)
			nameIcon = createNameIcon(OFF_COLOR);
		return nameIcon;
	}

	public static BufferedImage getSelectedNameIcon()
	{
		if (selectedNameIcon == null)
			selectedNameIcon = createNameIcon(ON_COLOR);
		return selectedNameIcon;
	}

	public static BufferedImage getUpSortIcon()
	{
		if (upSortIcon == null)
			upSortIcon = createUpSortIcon(OFF_COLOR);
		return upSortIcon;
	}

	public static BufferedImage getDownSortIcon()
	{
		if (downSortIcon == null)
			downSortIcon = createDownSortIcon(OFF_COLOR);
		return downSortIcon;
	}

	public static BufferedImage getRolloverDownSortIcon()
	{
		if (rolloverDownSortIcon == null)
			rolloverDownSortIcon = createDownSortIcon(ROLL_COLOR);
		return rolloverDownSortIcon;
	}

	public static BufferedImage getSelectedUpSortIcon()
	{
		if (selectedUpSortIcon == null)
			selectedUpSortIcon = createUpSortIcon(ON_COLOR);
		return selectedUpSortIcon;
	}

	public static BufferedImage getSelectedDownSortIcon()
	{
		if (selectedDownSortIcon == null)
			selectedDownSortIcon = createDownSortIcon(ON_COLOR);
		return selectedDownSortIcon;
	}

	public static BufferedImage getRolloverUpSortIcon()
	{
		if (rolloverUpSortIcon == null)
			rolloverUpSortIcon = createUpSortIcon(ROLL_COLOR);
		return rolloverUpSortIcon;
	}

	public static BufferedImage getLookupIcon()
	{
		if (lookupIcon == null)
			lookupIcon = createLookupIcon(OFF_COLOR);
		return lookupIcon;
	}

	public static BufferedImage getSelectedLookupIcon()
	{
		if (selectedLookupIcon == null)
			selectedLookupIcon = createLookupIcon(ON_COLOR);
		return selectedLookupIcon;
	}

	public static BufferedImage getRolloverLookupIcon()
	{
		if (rolloverLookupIcon == null)
			rolloverLookupIcon = createLookupIcon(ROLL_COLOR);
		return rolloverLookupIcon;
	}

	public static BufferedImage getGotoIcon()
	{
		if (gotoIcon == null)
			gotoIcon = createGotoIcon(OFF_COLOR);
		return gotoIcon;
	}

	public static BufferedImage getSelectedGotoIcon()
	{
		if (selectedGotoIcon == null)
			selectedGotoIcon = createGotoIcon(ON_COLOR);
		return selectedGotoIcon;
	}

	public static BufferedImage getRolloverGotoIcon()
	{
		if (rolloverGotoIcon == null)
			rolloverGotoIcon = createGotoIcon(ROLL_COLOR);
		return rolloverGotoIcon;
	}

	private static BufferedImage createErrorIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		Rectangle2D.Float rec = new Rectangle2D.Float(10, 3, 4, 10);
		big.fill(rec);
		gp.append(rec, false);
		Ellipse2D.Float dot = new Ellipse2D.Float(10, 17, 4, 4);
		big.fill(dot);
		gp.append(dot, false);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createNewIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(5f, 4f);
		gp.lineTo(5f, 20f);
		gp.lineTo(19f, 20f);
		gp.lineTo(19f, 9f);
		gp.lineTo(15f, 4f);
		gp.lineTo(5f, 4f);

		gp.moveTo(15f, 4f);
		gp.lineTo(15f, 9f);
		gp.lineTo(19f, 9f);

		big.draw(gp);
		return bi;
	}

	private static BufferedImage createSaveIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(3f, 3f);
		gp.lineTo(3f, 21f);
		gp.lineTo(21f, 21f);
		gp.lineTo(21f, 3f);
		gp.lineTo(3f, 3f);
		gp.moveTo(7f, 3f);
		gp.lineTo(7f, 11f);
		gp.lineTo(17f, 11f);
		gp.lineTo(17f, 3f);
		Rectangle2D.Float rec = new Rectangle2D.Float(8, 15, 4, 6);
		big.fill(rec);
		gp.append(rec, false);
		gp.moveTo(16f, 21f);
		gp.lineTo(16f, 15f);
		gp.lineTo(12f, 15f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createLockIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(6f, 9f);
		gp.lineTo(6f, 21f);
		gp.lineTo(18f, 21f);
		gp.lineTo(18f, 9f);
		gp.lineTo(6f, 9f);
		Arc2D.Float arc =
			new Arc2D.Float(8, 3, 8, 14, 0, 180, Arc2D.Float.OPEN);
		gp.append(arc, false);
		gp.moveTo(12f, 13f);
		gp.lineTo(12f, 17f);
		gp.lineTo(13f, 17f);
		gp.moveTo(12f, 13f);
		gp.lineTo(11f, 13f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createArrowIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 12f);
		gp.lineTo(12f, 20f);
		gp.moveTo(8f, 14f);
		gp.lineTo(12f, 4f);
		gp.lineTo(16f, 14f);
		gp.moveTo(8f, 14f);
		gp.lineTo(12f, 12f);
		gp.lineTo(16f, 14f);
		AffineTransform at = new AffineTransform();
		at.rotate(-Math.PI / 8, 12, 12);
		gp.transform(at);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createPencilIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(10f, 3f);
		gp.lineTo(14f, 3f);
		gp.lineTo(14f, 17f);
		gp.lineTo(12f, 21f);
		gp.lineTo(10f, 17f);
		gp.lineTo(10f, 3f);
		gp.moveTo(10f, 5f);
		gp.lineTo(14f, 5f);
		gp.moveTo(10f, 17f);
		gp.lineTo(14f, 17f);
		AffineTransform at = new AffineTransform();
		at.rotate(Math.PI / 6, 12, 12);
		gp.transform(at);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createEdgeIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 3f);
		gp.lineTo(12f, 21f);
		gp.moveTo(8f, 6f);
		gp.lineTo(12f, 3f);
		gp.lineTo(16f, 6f);
		gp.moveTo(8f, 18f);
		gp.lineTo(12f, 21f);
		gp.lineTo(16f, 18f);
		AffineTransform at = new AffineTransform();
		at.rotate(Math.PI / 6, 12, 12);
		gp.transform(at);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createMoveIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 3f);
		gp.lineTo(12f, 21f);
		gp.moveTo(9f, 6f);
		gp.lineTo(12f, 3f);
		gp.lineTo(15f, 6f);
		gp.moveTo(9f, 18f);
		gp.lineTo(12f, 21f);
		gp.lineTo(16f, 18f);

		gp.moveTo(3f, 12f);
		gp.lineTo(21f, 12f);
		gp.moveTo(6f, 9f);
		gp.lineTo(3f, 12f);
		gp.lineTo(6f, 15f);
		gp.moveTo(18f, 9f);
		gp.lineTo(21f, 12f);
		gp.lineTo(18f, 15f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createEditIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 7f);
		gp.lineTo(12f, 17f);
		Arc2D.Float topArc =
			new Arc2D.Float(8, -1, 8, 8, 0, -180, Arc2D.Float.OPEN);
		gp.append(topArc, false);
		Arc2D.Float bottomArc =
			new Arc2D.Float(8, 17, 8, 8, 0, 180, Arc2D.Float.OPEN);
		gp.append(bottomArc, false);
		AffineTransform at = new AffineTransform();
		at.rotate(Math.PI / 6, 12, 12);
		gp.transform(at);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createSmallEditIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(14, 14, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(new Color(224, 224, 224, 84)); //(255, 255, 255, 0));
		big.fillRect(0, 0, 14, 14);
		big.setStroke(new BasicStroke(1.0f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(7f, 4f);
		gp.lineTo(7f, 10f);
		Arc2D.Float topArc =
			new Arc2D.Float(5, -2, 4, 6, 0, -180, Arc2D.Float.OPEN);
		gp.append(topArc, false);
		Arc2D.Float bottomArc =
			new Arc2D.Float(5, 10, 4, 6, 0, 180, Arc2D.Float.OPEN);
		gp.append(bottomArc, false);
		AffineTransform at = new AffineTransform();
		at.rotate(Math.PI / 6, 7, 7);
		gp.transform(at);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createLookupIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(16, 16, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.C_GRAY);
		big.fillRect(0, 0, 16, 16);
		big.setStroke(new BasicStroke(1.0f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(3f, 2f);
		gp.lineTo(11f, 2f);
		gp.lineTo(11f, 12f);
		gp.lineTo(3f, 12f);
		gp.lineTo(3f, 2f);
		big.draw(gp);
		big.setStroke(new BasicStroke(0.5f));
		gp = new GeneralPath();
		gp.moveTo(6f, 5f);
		gp.lineTo(9f, 5f);
		gp.moveTo(6f, 7f);
		gp.lineTo(9f, 7f);
		gp.moveTo(6f, 9f);
		gp.lineTo(9f, 9f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createGotoIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(14, 14, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.C_GRAY);
		big.fillRect(0, 0, 14, 14);
		big.setStroke(new BasicStroke(1.0f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(8f, 3f);
		gp.lineTo(11f, 6f);
		gp.lineTo(8f, 9f);
		gp.moveTo(11f, 6f);
		gp.lineTo(3f, 6f);
		gp.lineTo(3f, 11f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createDeleteIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(7f, 7f);
		gp.lineTo(17f, 17f);
		gp.moveTo(17f, 7f);
		gp.lineTo(7f, 17f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createUndoIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(17f, 7f);
		gp.lineTo(7f, 12f);
		gp.lineTo(17f, 17f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createRedoIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(7f, 7f);
		gp.lineTo(17f, 12f);
		gp.lineTo(7f, 17f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createZoomInIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 14f);
		gp.lineTo(12f, 22f);
		Ellipse2D.Double lens = new Ellipse2D.Double(6, 2, 12, 12);
		gp.append(lens, false);
		gp.moveTo(9f, 8f);
		gp.lineTo(15f, 8f);
		gp.moveTo(12f, 5f);
		gp.lineTo(12f, 11f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createZoomOutIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(12f, 14f);
		gp.lineTo(12f, 22f);
		Ellipse2D.Double lens = new Ellipse2D.Double(6, 2, 12, 12);
		gp.append(lens, false);
		gp.moveTo(10f, 8f);
		gp.lineTo(14f, 8f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createImageIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(60, 10, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 60, 10);
		big.setColor(color);
		big.setFont(VPSettings.B_FONT);
		big.drawString("Image", 10, 2);
		return bi;
	}

	private static BufferedImage createNameIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(60, 10, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 60, 10);
		big.setColor(color);
		big.setFont(VPSettings.B_FONT);
		big.drawString("Name", 10, 2);
		return bi;
	}

	private static void createVPIcon()
	{
		vpIcon = new BufferedImage(24, 24, BufferedImage.TYPE_INT_RGB);
		Graphics2D big = vpIcon.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(Color.green);
		big.setStroke(new BasicStroke(3.0f));
		big.drawLine(4, 4, 11, 20);
		big.drawLine(13, 4, 13, 20);
		big.draw(new Arc2D.Double(6, 4, 14, 10, 90, -180, Arc2D.Double.OPEN));
	}

	private static BufferedImage createUpSortIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(8, 15, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 8, 15);
		big.setStroke(new BasicStroke(1.3f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(1f, 6f);
		gp.lineTo(4f, 1f);
		gp.lineTo(7f, 6f);
		gp.moveTo(4f, 1f);
		gp.lineTo(4f, 15f);
		big.draw(gp);
		return bi;
	}

	private static BufferedImage createDownSortIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(8, 15, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 8, 15);
		big.setStroke(new BasicStroke(1.3f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();
		gp.moveTo(1f, 9f);
		gp.lineTo(4f, 14f);
		gp.lineTo(7f, 9f);
		gp.moveTo(4f, 14f);
		gp.lineTo(4f, 1f);
		big.draw(gp);
		return bi;
	}
	/**
	 * @return
	 */
	public static BufferedImage getGeneIcon()
	{
		if (geneIcon == null)
			geneIcon = createGeneIcon(OFF_COLOR);
		return geneIcon;
	}

	/**
	 * @param OFF_COLOR
	 * @return
	 */
	private static BufferedImage createGeneIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();

		gp.append(
			new CubicCurve2D.Double(8, 3, 8, 7.5, 15, 7.5, 15, 12),
			false);
		gp.append(
			new CubicCurve2D.Double(15, 3, 15, 7.5, 8, 7.5, 8, 12),
			false);
		gp.append(
			new CubicCurve2D.Double(8, 12, 8, 16.5, 15, 16.5, 15, 21),
			false);
		gp.append(
			new CubicCurve2D.Double(15, 12, 15, 16.5, 8, 16.5, 8, 21),
			false);
		big.draw(gp);
		big.setStroke(new BasicStroke(1.0f));
		//big.drawLine(9, 3, 15, 3);
		//big.drawLine(9, 12, 15, 12);
		//big.drawLine(9, 21, 15, 21);
		return bi;
	}

	/**
	 * @return
	 */
	public static BufferedImage getRolloverGeneIcon()
	{
		if (rolloverGeneIcon == null)
			rolloverGeneIcon = createGeneIcon(ROLL_COLOR);
		return rolloverGeneIcon;
	}

	/**
	 * @return
	 */
	public static BufferedImage getSelectedGeneIcon()
	{
		if (selectedGeneIcon == null)
			selectedGeneIcon = createGeneIcon(ON_COLOR);
		return selectedGeneIcon;
	}

	public static BufferedImage getEnzymeIcon()
	{
		if (enzymeIcon == null)
			enzymeIcon = createEnzymeIcon(OFF_COLOR);
		return enzymeIcon;
	}

	/**
	 * @param OFF_COLOR
	 * @return
	 */
	private static BufferedImage createEnzymeIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();

		gp.append(new CubicCurve2D.Double(4, 20, 4, 16, 20, 20, 20, 16), false);
		gp.append(new CubicCurve2D.Double(20, 16, 20, 12, 4, 16, 4, 12), false);
		gp.append(new CubicCurve2D.Double(4, 12, 4, 8, 20, 12, 20, 8), false);
		gp.append(new CubicCurve2D.Double(20, 8, 20, 4, 4, 8, 4, 4), false);
		big.draw(gp);
		return bi;
	}

	/**
	 * @return
	 */
	public static BufferedImage getRolloverEnzymeIcon()
	{
		if (rolloverEnzymeIcon == null)
			rolloverEnzymeIcon = createEnzymeIcon(ROLL_COLOR);
		return rolloverEnzymeIcon;
	}

	/**
	 * @return
	 */
	public static BufferedImage getSelectedEnzymeIcon()
	{
		if (selectedEnzymeIcon == null)
			selectedEnzymeIcon = createEnzymeIcon(ON_COLOR);
		return selectedEnzymeIcon;
	}

	public static BufferedImage getExperimentIcon()
	{
		if (experimentIcon == null)
			experimentIcon = createExperimentIcon(OFF_COLOR);
		return experimentIcon;
	}

	/**
	 * @param OFF_COLOR
	 * @return
	 */
	private static BufferedImage createExperimentIcon(Color color)
	{
		BufferedImage bi =
			new BufferedImage(24, 24, BufferedImage.TYPE_INT_ARGB);
		Graphics2D big = bi.createGraphics();
		big.setRenderingHint(
			RenderingHints.KEY_ANTIALIASING,
			RenderingHints.VALUE_ANTIALIAS_ON);
		big.setColor(VPSettings.Colors.CLEAR);
		big.fillRect(0, 0, 24, 24);
		big.setStroke(new BasicStroke(1.75f));
		big.setColor(color);
		GeneralPath gp = new GeneralPath();

		gp.moveTo(10, 4);
		gp.lineTo(14, 4);
		gp.lineTo(14, 12);
		gp.moveTo(10, 4);
		gp.lineTo(10, 12);
		gp.moveTo(4, 20);
		gp.lineTo(20, 20);
		gp.moveTo(10, 12);
		gp.lineTo(14, 12);
		gp.append(new CubicCurve2D.Double(10, 12, 10, 16, 4, 16, 4, 20), false);
		gp.append(
			new CubicCurve2D.Double(14, 12, 14, 16, 20, 16, 20, 20),
			false);
		big.draw(gp);
		return bi;
	}

	/**
	 * @return
	 */
	public static BufferedImage getRolloverExperimentIcon()
	{
		if (rolloverExperimentIcon == null)
			rolloverExperimentIcon = createExperimentIcon(ROLL_COLOR);
		return rolloverExperimentIcon;
	}

	/**
	 * @return
	 */
	public static BufferedImage getSelectedExperimentIcon()
	{
		if (selectedExperimentIcon == null)
			selectedExperimentIcon = createExperimentIcon(ON_COLOR);
		return selectedExperimentIcon;
	}

}
