/*
 * Created on Apr 27, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.util;

import java.util.Stack;

import javax.swing.AbstractButton;

import org.w3c.dom.Document;

import vp.graph.PathwayGraph;
import vp.main.MainFrame;
import vp.util.xml.GraphToXML;
import vp.util.xml.XMLToGraph;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class UndoRedoStack
{
	private MainFrame parent;
	private VPStack redoStack;
	private VPStack undoStack;
	private final int UNDO = 1;
	private final int REDO = 2;

	public UndoRedoStack(MainFrame parent)
	{
		this.parent = parent;
		undoStack = new VPStack(UNDO);
		redoStack = new VPStack(REDO);
	}
	public void store(PathwayGraph pg)
	{
		undoStack.pushGraph(pg);
		redoStack.clear();
	}

	public PathwayGraph undo(PathwayGraph pg)
	{
        redoStack.pushGraph(pg);

		PathwayGraph newPg = undoStack.popGraph(pg);
		
		return newPg;
	}

	public PathwayGraph redo(PathwayGraph vg)
	{
		undoStack.pushGraph(vg);
		PathwayGraph newVg = redoStack.popGraph(vg);

		return newVg;
	}

	private class VPStack extends Stack
	{
		/* (non-Javadoc)
		* @see java.util.Stack#push(java.lang.Object)
		*/
		private AbstractButton button;

		public VPStack(int type)
		{
			switch (type)
			{
				case UNDO :
					button = parent.getToolBar().getUndoButton();
					break;
				case REDO :
					button = parent.getToolBar().getRedoButton();
					break;
				default :
					button = null;
					break;
			}
		}
		/* (non-Javadoc)
		 * @see java.util.Stack#pop()
		 */
		public PathwayGraph popGraph(PathwayGraph pg)
		{
			Document topDoc = (Document)pop();
			if (isEmpty())
				button.setEnabled(false);
			pg.clearAll();
			PathwayGraph returnPg = XMLToGraph.loadDocument(topDoc, pg);
			return returnPg;
		}

		/* (non-Javadoc)
		 * @see java.util.Stack#push(java.lang.Object)
		 */
		public Object pushGraph(PathwayGraph pg)
		{
			Document newDoc = GraphToXML.generateDocument(pg);
			if (isEmpty())
				button.setEnabled(true);

			return push(newDoc);
		}
		/* (non-Javadoc)
		 * @see java.util.Collection#clear()
		 */
		public void clear()
		{
			super.clear();
			button.setEnabled(false);
		}

	}

}
