/*
 * Created on Apr 8, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.util;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.StringTokenizer;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VPProperties
{
    private static String filePath;
	/**
	 * @author Matt Holford
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private static class TimeTableEntry
	{
		TimeTableEntry(String key, String value, String iterations)
		{
			int iter = Integer.valueOf(iterations).intValue();
			for (int i = 0; i < iter; i++)
			{
				reportTime(key, Integer.valueOf(value).intValue());
			}
		}
	}
	private static Hashtable ht = new Hashtable();
	private static final int TIMETABLE_SIZE = 10;

	private VPProperties()
	{}
    
    public static void setFilePath(String path)
    {
        filePath = path;
    }
    
    public static String getFilePath()
    {
        return filePath;
    }

	public static void readProperties()
	{
		File propFile =
			new File("vp.properties");
		if (!propFile.exists())
		{
			installDefaultProperties();
			return;
		}

		BufferedReader br = null;
		try
		{
			br = new BufferedReader(new FileReader(propFile));
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		String s;
		try
		{
			while ((s = br.readLine()) != null)
			{
				StringTokenizer stkr = new StringTokenizer(s);

				TimeTableEntry tte =
					new TimeTableEntry(
						stkr.nextToken(),
						stkr.nextToken(),
						stkr.nextToken());
			}
		}
		catch (IOException e1)
		{
			e1.printStackTrace();
		}
	}

	public static void writeProperties()
	{
		File propFile =
			new File("vp.properties");
		BufferedWriter bw = null;
		try
		{
			bw = new BufferedWriter(new FileWriter(propFile));
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		Iterator iter = ht.keySet().iterator();
		while (iter.hasNext())
		{
			String key = (String)iter.next();
			int time = getTime(key);
			int iterations = getLength((Integer[])ht.get(key));
			try
			{
				bw.write(key + "\t" + time + "\t" + iterations + "\n");
				bw.flush();
			}
			catch (IOException e1)
			{
				e1.printStackTrace();
			}
		}
	}

	/**
	 * 
	 */
	private static void installDefaultProperties()
	{
		for (int i = 0; i < 3; i++)
		{
			reportTime("LoadEnzymeDisplayPanel", 2000);
            reportTime("InitializeDatabase", 422);
            reportTime("MatchCompounds", 250);
            reportTime("MatchEnzymes", 250);
            reportTime("queryDatabase", 5000);
            reportTime("generateGraph", 5);
            reportTime("runAlgorithm", 50);
            reportTime("loadExperimentValues", 5);
		}
	}

	public static void reportTime(String key, int time)
	{
		if (ht.get(key) == null)
		{
			ht.put(key, new Integer[TIMETABLE_SIZE]);
		}
		Integer[] times = (Integer[])ht.get(key);
		int length = getLength(times);
		if (length < TIMETABLE_SIZE)
		{
			times[length] = new Integer(time);
		}
		//		else if (times[length - 1] == null)
		//		{
		//			times[length - 1] = new Integer(time);
		//		}
		else
		{

			for (int i = 1; i < TIMETABLE_SIZE; i++)
			{
				times[i - 1] = times[i];
			}
			times[TIMETABLE_SIZE - 1] = new Integer(time);
		}
	}

	/**
	 * @param times
	 * @return
	 */
	private static int getLength(Integer[] times)
	{
		for (int i = 0; i < times.length; i++)
		{
			if (times[i] == null)
				return i;

		}
		return times.length;
	}

	public static int getTime(String key)
	{
		int time = 0;

		Integer[] chronTimes = (Integer[])ht.get(key);

		int length = getLength(chronTimes);
		Integer[] sortTimes = new Integer[length];
		System.arraycopy(chronTimes, 0, sortTimes, 0, length);
		Arrays.sort(sortTimes);
		int total = 0;
		//Ignore highest and lowest values
		for (int i = 1; i < sortTimes.length - 1; i++)
		{
			total += sortTimes[i].intValue();
		}
		time = total / (sortTimes.length - 2);
		return time;
	}

	public static void main(String[] args)
	{
		for (int i = 0; i < 3; i++)
		{
			VPProperties.reportTime("test", 150);
			VPProperties.reportTime("test", 200);
			VPProperties.reportTime("test", 250);
		}
		VPProperties.reportTime("test", 300);
		VPProperties.reportTime("test", 400);
		int avgTime = VPProperties.getTime("test");
	}
}
