package vp.util.geom;


import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

public class CurvePath
{
	private static int numPoints;
	private static Point2D.Double[] curvePt;

	private CurvePath()
	{
	}

	public static GeneralPath getCurvePath(Point2D.Double curveStart, Point2D.Double curveEnd, double pos)
	{
		GeneralPath drawPath = new GeneralPath();
/*
		Equation eq = Geometry.getEquation(curveStart, curveEnd);
		float xSpan = Math.max(curveStart.x, curveEnd.x) - Math.min(curveStart.x, curveEnd.x);
		float perpSlope = 1 / eq.slope;
		Point2D.Float mid = Geometry.getMidpoint(curveStart, curveEnd);
		float endX = mid.x;
		
		float endY = (perpSlope * endX) + eq.yOffset;
*/
		double distance = Point2D.distance(curveStart.x, curveStart.y, curveEnd.x, curveEnd.y);
		Point2D.Double control = Geometry.getPtOnPerp(curveStart, curveEnd, 0.5d, (int)(distance * .66), pos);
		
		curvePt = Geometry.getBezier(curveStart, control, curveEnd);
		numPoints = curvePt.length;

		drawPath.reset();
		drawPath.moveTo((float)curvePt[0].x, (float)curvePt[0].y);
		for (int i = 1;i < curvePt.length ;i++ )
		{
			drawPath.lineTo((float) curvePt[i].x, (float) curvePt[i].y);
		}
		drawPath.lineTo((float)curveEnd.x, (float)curveEnd.y);
		return drawPath;
/*
		float startX = curveStart.x;
		float startY = curveStart.y;
		float endX = curveEnd.x;
		float endY = curveEnd.y;

		float a = endX - startX;
		float b = endY - startY;
		
		numPoints = 10;
		xpoints = new float[numPoints];
		ypoints = new float[numPoints];
		
		float tmin = 0;
		float tmax = (float)Math.PI/2;
		float tspan = (tmax - tmin) / numPoints;

		for (int i = 0;i < numPoints ;i++ )
		{
			float t = tmin + (tspan * i);
			float xpoint = a * (float)Math.cos(t);
			float ypoint = b * (float)Math.sin(t);
			

			//adjust to our coords

			xpoints[i] = -xpoint + endX;
			ypoints[i] = ypoint + startY;
		}

		//define path of curve as lines between these points
		drawPath.reset();
		drawPath.moveTo((float)xpoints[0], (float)ypoints[0]);
		for (int i = 1; i < numPoints ;i++ )
		{
			drawPath.lineTo((float)xpoints[i], (float)ypoints[i]);
		}
		drawPath.lineTo((float)curveEnd.x, (float)curveEnd.y);

		return drawPath;
*/
	}

	public static Point2D.Double getLinkPosition(Point2D.Double curveStart, Point2D.Double curveEnd, double linkPosition)
	{
		int curvePointNum = (int)((numPoints-1) * linkPosition);
		getCurvePath(curveStart, curveEnd, 1);
		return curvePt[curvePointNum];
	}

	public static GeneralPath getCurveClickPath(Point2D.Double p1, Point2D.Double p2, Point2D.Double p3, Point2D.Double p4)
	{
		GeneralPath clickPath = new GeneralPath();

		clickPath.moveTo((float)p1.x, (float)p1.y);
		clickPath.lineTo((float)p3.x, (float)p3.y);
		clickPath.append(getCurvePath(p3, p4, 1), false);
		clickPath.lineTo((float)p2.x, (float)p2.y);
		clickPath.append(getCurvePath(p1, p2, 1), false);
		
		return clickPath;
	}
}
