package vp.util.geom;

import java.awt.geom.Point2D;

public class Equation
{
	public double slope = 0;
	public double yOffset = 0;

	protected Equation(Point2D.Double p1, Point2D.Double p2)
	{
		double divisor = (p1.x == p2.x) ? .1d : p2.x - p1.x;
		slope = (p2.y - p1.y) / divisor;
		yOffset = (slope * - (p1.x)) + p1.y;
	}

	public double getYValue(double xValue)
	{
		return (slope * xValue) + yOffset;
	}

	public double getXValue(double yValue)
	{
		return (yValue - yOffset) / slope;
	}
}
