package vp.util.xml;

import java.io.File;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentType;
import org.w3c.dom.DOMImplementation;

public class XMLFactory
{

	private XMLFactory()
	{}

	public static Document getSaveDocument()
	{
		Document doc = null;
		try
		{
			DocumentBuilderFactory factory =
				DocumentBuilderFactory.newInstance();
			DocumentBuilder builder = factory.newDocumentBuilder();
			DOMImplementation implement = builder.getDOMImplementation();
			factory.setValidating(false);
			DocumentType docType =
				implement.createDocumentType("GRAPH", "", "Graph.dtd");
			doc = implement.createDocument("", "GRAPH", docType);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return doc;
	}

	public static Document getLoadDocument(File file)
	{
		Document doc = null;
		try
		{
			DocumentBuilderFactory factory =
				DocumentBuilderFactory.newInstance();
			
            factory.setValidating(true);
            factory.setIgnoringElementContentWhitespace(true);
            DocumentBuilder builder = factory.newDocumentBuilder();
            builder.setErrorHandler(null);
            builder.setEntityResolver(null);
			doc = builder.parse(file);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return doc;
	}
}
