/*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.visual;

import java.awt.geom.GeneralPath;

import vp.graph.PathwayDecoration;
import vp.visual.paint.DecorationPainter;
import vp.visual.paint.DecorationPainterFactoryImp;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class DecorationRenderer extends AbstractLabeledRenderer
{
	private PathwayDecoration decoration;

	public DecorationRenderer(DecorationRenderer renderer, PathwayDecoration element)
	{
        decoration = element;
		this.element = element;
		type = renderer.getType().newInstance();
		drawPath = type.getGeneralPath();
		painter = DecorationPainterFactoryImp.getInstance().getPainter();
		setLocation(0, 0);
	}

	public DecorationRenderer(PathwayDecoration decoration)
	{
		this.decoration = decoration;
		this.element = decoration;
		type = decoration.getType().newInstance();
		drawPath = type.getGeneralPath();
		painter = DecorationPainterFactoryImp.getInstance().getPainter();
		setLocation(0, 0);

		//rescale();
	}

	/* (non-Javadoc)
	 * @see vp.visual.LabeledRenderer#rescale()
	 */
	public void rescale()
	{
		((DecorationPainter)painter).rescale(decoration);
	}

	public void setGeneralPath(GeneralPath drawPath)
	{
		drawPath.closePath();
		this.drawPath = drawPath;
		type.setGeneralPath(drawPath);
		rescale();
	}

	public String getLabel()
	{
		return decoration.getLabel();
	}
}
