/*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.visual;

import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import vp.graph.PathwayEdge;
import vp.util.geom.Geometry;
import vp.visual.paint.EdgePainterFactoryImp;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class EdgeRenderer extends AbstractRenderer
{
	private GeneralPath clickPath;
	private float curvature;
	private PathwayEdge edge;

	public EdgeRenderer(EdgeRenderer renderer, PathwayEdge element)
	{
		this.element = element;
		type = renderer.getType().newInstance();
		painter = EdgePainterFactoryImp.getInstance().getPainter();
		drawPath = new GeneralPath();
		clickPath = new GeneralPath();
	}

	public EdgeRenderer(PathwayEdge edge)
	{
		this.edge = edge;
		this.element = edge;
		type = edge.getType().newInstance();
		curvature = type.getCurvature();
		painter = EdgePainterFactoryImp.getInstance().getPainter();
		drawPath = new GeneralPath();
		clickPath = new GeneralPath();
	}
	/**
	 * @return
	 */
	public GeneralPath getClickPath()
	{
		return clickPath;
	}

	/**
	 * @return
	 */
	public float getCurvature()
	{
		return curvature;
	}

	/**
	 * @param path
	 */
	public void setClickPath(GeneralPath path)
	{
		clickPath = path;
	}

	/**
	 * @param f
	 */
	public void setCurvature(float f)
	{
		curvature = f;
	}

	public Point2D.Double getLinkPosition(PathwayEdge edge, double linkRatio)
	{
		return Geometry.getLinkPosition(edge, linkRatio);
	}

}
