/*
 * Created on Jul 2, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.visual;

import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics2D;
import java.util.List;
import java.util.Map;

import vp.graph.PathwayDecoration;
import vp.graph.PathwayEdge;
import vp.graph.PathwayVertex;
import vp.visual.paint.DecorationPainterFactory;
import vp.visual.paint.EdgePainterFactory;
import vp.visual.paint.VertexPainterFactory;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public interface GraphRenderer
{
    public void addContainer(Container c);
    
    public List getContainers();
    
    public PathwayDecoration getSelectedDecoration(int x, int y);
    
    public PathwayEdge getSelectedEdge(int x, int y);
    
    public Dimension getMaxSize();
    
    public PathwayVertex getSelectedVertex(int x, int y);
    
    public DecorationPainterFactory getDecorationPainterFactory();
    
    public EdgePainterFactory getEdgePainterFactory();
    
    public VertexPainterFactory getVertexPainterFactory();
    
    public boolean isLocked();
    
    public void paint(Graphics2D g2);
    
    public void removeContainer(Container c);
    
    public void repaint();
    
    public void setExperimentData(Map data);
    
    public void setLocked(boolean locked);
    
    public void setDecorationPainterFactory(DecorationPainterFactory dpf);
    
    public void setEdgePainterFactory(EdgePainterFactory epf);
    
    public void setVertexPainterFactory(VertexPainterFactory vpf);
}
