/*
 * Created on Jul 2, 2004
 * 
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
 * Comments
 */
package vp.visual;

import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.geom.Point2D;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import vp.graph.DummyVertex;
import vp.graph.PathwayDecoration;
import vp.graph.PathwayEdge;
import vp.graph.PathwayGraph;
import vp.graph.PathwayVertex;
import vp.gui.dialogs.LoadFlatFileDialog;
import vp.visual.graphics.AnimatedElement;
import vp.visual.paint.DecorationPainterFactoryImp;
import vp.visual.paint.EdgePainterFactoryImp;
import vp.visual.paint.VertexPainterFactoryImp;
import vp.visual.type.Type;

/**
 * @author Matt Holford
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and
 * Comments
 */
public class VPGraphRenderer extends AbstractGraphRenderer
{
    private List animatedElements;

    private int count;

    public VPGraphRenderer(PathwayGraph pg)
    {
        this.pg = pg;
        containers = new ArrayList();
        animatedElements = new ArrayList();
        dpf = DecorationPainterFactoryImp.getInstance();
        epf = EdgePainterFactoryImp.getInstance();
        vpf = VertexPainterFactoryImp.getInstance();
    }

    /*
     * (non-Javadoc)
     * 
     * @see vp.visual.AbstractGraphRenderer#paint()
     */
    public void paint(Graphics2D g2)
    {
        ListIterator iter;
        PathwayVertex pv;
        PathwayEdge pe;

        iter = pg.getVertexIterator();
        while (iter.hasNext())
        {
            pv = (PathwayVertex) iter.next();

            if (pv instanceof DummyVertex)
            {
                PathwayEdge linkEdge = null;
                int onLink = pv.getOnLink();
                ListIterator newIter = pg.getEdgeIterator();
                while (newIter.hasNext())
                {
                    PathwayEdge current = (PathwayEdge) newIter
                        .next();
                    if (current.getID() == onLink)
                    {
                        linkEdge = current;
                        break;
                    }
                }
                Point2D.Double onLinkPos = linkEdge
                    .getLinkPosition(pv.getOnLinkPosition());
                pv.setLocation(onLinkPos.x, onLinkPos.y);
            }
            pv.paint(g2);
        }

        iter = pg.getEdgeIterator();
        PathwayEdge paintLast = null;
        while (iter.hasNext())
        {
            pe = (PathwayEdge) iter.next();
            ListIterator veIter = pe.getDecorationIterator();
            while (veIter.hasNext())
            {
                PathwayDecoration pd = (PathwayDecoration) veIter
                    .next();
                if (pd.isTipEnabled())
                    paintLast = pe;
            }
            if (pe != paintLast)
                pe.paint(g2);
        }
        if (paintLast != null)
            paintLast.paint(g2);

        ListIterator iter2 = animatedElements.listIterator();
        while (iter2.hasNext())
        {
            AnimatedElement ae = (AnimatedElement) iter2.next();
            ae.paint(g2, count);
        }
        count++;

    }

    /*
     * (non-Javadoc)
     * 
     * @see vp.visual.AbstractGraphRenderer#repaint()
     */
    public void repaint()
    {
        ListIterator iter = containers.listIterator();
        Container cont;

        while (iter.hasNext())
        {
            cont = (Container) iter.next();
            if (cont != null)
                cont.repaint();
        }
    }

    /*
     * (non-Javadoc)
     * 
     * @see vp.visual.AbstractGraphRenderer#setExperimentData(java.util.Map)
     */
    public void setExperimentData(Map data)
    {
    }

    public void addAnimatedElement(AnimatedElement ae)
    {
        animatedElements.add(ae);
    }

    public void removeAnimatedElement(AnimatedElement ae)
    {
        ListIterator iter = animatedElements.listIterator();
        while (iter.hasNext())
        {
            AnimatedElement curr = (AnimatedElement) iter.next();
            if (curr == ae)
            {
                ae.kill();
                break;
            }
        }
        animatedElements.remove(ae);
    }

    public void removeAllAnimatedElements()
    {
        ListIterator iter = animatedElements.listIterator();
        while (iter.hasNext())
        {
            AnimatedElement ae = (AnimatedElement) iter.next();
            ae.kill();
        }
        animatedElements.clear();
        repaint();
    }

    public void clearHighlightedElements()
    {
        if (!(pg.getParent().getCurrEditComponent() instanceof LoadFlatFileDialog))
            pg.getParent().clearEditPanel();

        ListIterator lit = pg.getVertexIterator();
        while (lit.hasNext())
        {
            ((PathwayVertex) lit.next()).setTexturePaint(null);
        }

        lit = pg.getEdgeIterator();
        while (lit.hasNext())
        {
            ((PathwayEdge) lit.next()).setTexturePaint(null);
        }
    }

    /**
     * @param i
     * @param localCompoundType
     */
    public void setDefaultType(int i, Type localCompoundType)
    {
    }
}
