/*
 * Created on Jul 1, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.visual;

import java.awt.geom.GeneralPath;

import vp.graph.PathwayVertex;
import vp.visual.paint.VertexPainter;
import vp.visual.paint.VertexPainterFactoryImp;

/**
 * @author Matt Holford
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class VertexRenderer extends AbstractLabeledRenderer
{

	/**
	     * @param renderer
	     */
	public VertexRenderer(VertexRenderer renderer, PathwayVertex element)
	{
		this.element = element;
		type = renderer.getType().newInstance();
		drawPath = type.getGeneralPath();
		painter = VertexPainterFactoryImp.getInstance().getPainter();
		setLocation(
			((PathwayVertex)element).getXPosition(),
			((PathwayVertex)element).getYPosition());
	}

	public VertexRenderer(PathwayVertex element)
	{
		this.element = element;
		type = ((PathwayVertex)element).getType().newInstance();
		drawPath = type.getGeneralPath();
		painter = VertexPainterFactoryImp.getInstance().getPainter();
		setLocation(
			((PathwayVertex)element).getXPosition(),
			((PathwayVertex)element).getYPosition());
		//rescale();
	}

	/* (non-Javadoc)
	 * @see vp.visual.LabeledRenderer#rescale()
	 */
	public void rescale()
	{
		((VertexPainter)painter).rescale(element);
	}

	/* (non-Javadoc)
	 * @see vp.visual.Renderer#setGeneralPath(java.awt.geom.GeneralPath)
	 */
	public void setGeneralPath(GeneralPath drawPath)
	{
		drawPath.closePath();
		this.drawPath = drawPath;
		type.setGeneralPath(drawPath);
		rescale();
	}

	/**
	 * @return
	 */
	public String getLabel()
	{
		return ((PathwayVertex)element).getLabel();
	}
}
