/*
 * Created on Mar 17, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package vp.visual.graphics;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Point;

import javax.swing.Timer;

import vp.graph.PathwayGraph;
import vp.gui.VPSettings;

/**
 * @author Matt
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class AnimatedCrosshair extends AnimatedElement
{
	private static AnimatedCrosshair instance;

	private Color colorA;

	private Color colorB;

	private int endY;

	private int endX;

	private int startY;

	private int startX;

	private int size;

	private Point loc;

	private AnimatedCrosshair(PathwayGraph vGraph, Point[] locations)
	{
		this.pGraph = vGraph;
		this.locations = locations;
		delay = 25;
		loc = locations[0];
		size = 20;
		colorB = VPSettings.Colors.D_BLUE;
		colorA = VPSettings.Colors.L_BLUE;
		timer = new Timer(delay, this);
		timer.start();
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.graph.visual.AnimatedElement#getInstance()
	 */
	public static AnimatedCrosshair getInstance(
		PathwayGraph pGraph,
		Point[] loc)
	{
		//if(instance == null)
		instance = new AnimatedCrosshair(pGraph, loc);
		return instance;
	}

	/* (non-Javadoc)
	 * @see vp.src.edu.yale.graph.visual.AnimatedElement#paint(java.awt.Graphics2D, int)
	 */
	public void paint(Graphics2D g2, int count)
	{
		count = count % 40;
		startX = loc.x - (size / 2);
		startY = loc.y - (size / 2);
		endX = loc.x + (size / 2);
		endY = loc.y + (size / 2);
		g2.setStroke(new BasicStroke(1.5f));
		if (count < (size / 2))
		{
			g2.setColor(colorB);
			g2.drawLine(startX, loc.y, startX + count, loc.y);
			g2.drawLine(endX, loc.y, endX - count, loc.y);
			g2.drawLine(loc.x, startY, loc.x, startY + count);
			g2.drawLine(loc.x, endY, loc.x, endY - count);
			g2.setColor(colorA);
			g2.drawLine(startX + count, loc.y, endX - count, loc.y);
			g2.drawLine(loc.x, startY + count, loc.x, endY - count);
		}
		else if (count < size)
		{
			int count2 = count - (size / 2);
			g2.setColor(colorA);
			g2.drawLine(startX, loc.y, startX + count2, loc.y);
			g2.drawLine(endX, loc.y, endX - count2, loc.y);
			g2.drawLine(loc.x, startY, loc.x, startY + count2);
			g2.drawLine(loc.x, endY, loc.x, endY - count2);
			g2.setColor(colorB);
			g2.drawLine(startX + count2, loc.y, endX - count2, loc.y);
			g2.drawLine(loc.x, startY + count2, loc.x, endY - count2);
		}
		else if (count < (size + (size / 2)))
		{
			int count3 = 10 - (count - size);
			g2.setColor(colorA);
			g2.drawLine(startX, loc.y, startX + count3, loc.y);
			g2.drawLine(endX, loc.y, endX - count3, loc.y);
			g2.drawLine(loc.x, startY, loc.x, startY + count3);
			g2.drawLine(loc.x, endY, loc.x, endY - count3);
			g2.setColor(colorB);
			g2.drawLine(startX + count3, loc.y, endX - count3, loc.y);
			g2.drawLine(loc.x, startY + count3, loc.x, endY - count3);
		}
		else
		{
			int count4 = 10 - (count - (size + (size / 2)));
			g2.setColor(colorB);
			g2.drawLine(startX, loc.y, startX + count4, loc.y);
			g2.drawLine(endX, loc.y, endX - count4, loc.y);
			g2.drawLine(loc.x, startY, loc.x, startY + count4);
			g2.drawLine(loc.x, endY, loc.x, endY - count4);
			g2.setColor(colorA);
			g2.drawLine(startX + count4, loc.y, endX - count4, loc.y);
			g2.drawLine(loc.x, startY + count4, loc.x, endY - count4);
		}
		g2.setStroke(new BasicStroke(1.0f));
	}

}
