package vp.visual.graphics;

import java.awt.Polygon;
import java.awt.geom.AffineTransform;
import java.awt.geom.GeneralPath;
import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

public class Arrowhead
{

	private Arrowhead()
	{}

	public static GeneralPath getArrowhead(
		Point2D.Double tip,
		Line2D.Double line)
	{
		GeneralPath ahead = new GeneralPath();
		Polygon p = new Polygon();
		p.addPoint((int)tip.x - 5, (int)tip.y + 12);
		p.addPoint((int)tip.x, (int)tip.y);
		p.addPoint((int)tip.x + 5, (int)tip.y + 12);
		p.addPoint((int)tip.x, (int)tip.y + 8);
		ahead.append(p, false);
		Point2D.Double hyp = new Point2D.Double(line.getX2(), line.getY1());
		double h =
			Point2D.distance(
				line.getX1(),
				line.getY1(),
				line.getX2(),
				line.getY2());
		double a = Point2D.distance(line.getX2(), line.getY2(), hyp.x, hyp.y);
		double rot = Math.acos(a / h);

		if ((line.x2 > line.x1) && (line.y2 >= line.y1))
			rot = Math.PI + (Math.PI - rot);

		else if ((line.x2 < line.x1) && (line.y2 < line.y1))
			rot = Math.PI - rot;

		else if ((line.x2 >= line.x1) && (line.y2 < line.y1))
			rot = rot + Math.PI;

		AffineTransform at = new AffineTransform();
		at.rotate(rot, tip.x, tip.y);
		ahead.transform(at);
		return ahead;
	}
}
