package vp.visual.paint;

/**
* A singleton class that assigns the painter for visual decorations.  Currently this is handled by the <code>
* VisualVertexPainterImp</code> class.
*
* @see edu.yale.graph.visual.painting.VisualVertexPainterImp
*/
public final class DecorationPainterFactoryImp
	implements DecorationPainterFactory
{

	private static DecorationPainterFactoryImp instance;
	private DecorationPainter painter;

	private DecorationPainterFactoryImp()
	{}

	/**
	* Returns the single instance of this class.
	*/
	public static DecorationPainterFactoryImp getInstance()
	{
		if (instance == null)
			instance = new DecorationPainterFactoryImp();
		return instance;
	}

	/**
	* Returns the painter to be used for this element.
	*/
	public Painter getPainter()
	{
		if (painter == null)
			painter = new DecorationPainterImp();
		return painter;
	}
}
