package vp.visual.paint;

import java.awt.Graphics2D;

import vp.graph.PathwayEdge;

/**
* An interface for the painting of visual edges.  It is implemented by <code>VisualEdgePainterImp</code>.
*
* @see edu.yale.graph.visual.painting.VisualEdgePainterImp
*/
public interface EdgePainter extends Painter
{
	/**
	* Paints the decorations associated with the edge.
	*/
	void paintDecorations(PathwayEdge pe, Graphics2D g2);

	/**
	* Paints the arrowhead indicating the direction of the edge.
	*/
	void paintArrowhead(PathwayEdge pe, Graphics2D g2, boolean forward);
}
