package vp.visual.paint;

/**
* A singleton class that assigns the painter for visual edges.  Currently this is handled by the <code>
* VisualEdgePainterImp</code> class.
*
* @see edu.yale.graph.visual.painting.VisualEdgePainterImp
*/
public final class EdgePainterFactoryImp
	implements EdgePainterFactory
{
	private static EdgePainterFactoryImp instance;
	private EdgePainter painter;

	private EdgePainterFactoryImp()
	{}

	/**
	* Returns the single instance of this class.
	*/
	public static EdgePainterFactoryImp getInstance()
	{
		if (instance == null)
			instance = new EdgePainterFactoryImp();
		return instance;
	}

	/**
	* Returns the painter to be used for this element.
	*/
	public Painter getPainter()
	{
		if (painter == null)
			painter = new EdgePainterImp();
		return painter;
	}
}
