package vp.visual.paint;

import vp.graph.PathwayElement;
import java.awt.Graphics2D;

/**
* An interface which handles the painting duties for all visual graph elements.  The specific painter is assigned by 
* the <code>PainterFactory</code> classes.
*
* @see edu.yale.graph.visual.painting.PainterFactory
*/
public interface Painter
{
	/**
	* Paint the component.
	*
	* @param element	The visual element to be painted.
	* @param g2	The graphics context in which to paint.
	*/
	void paint(PathwayElement element, Graphics2D g2);
}
