package vp.visual.paint;

/**
* An interface which assigns the painting duties for a visual element.  The derived classes are singletons which assign
* a specific <code>Painter</code> class.
* 
* @see edu.yale.graph.visual.painting.Painter
*/
public interface PainterFactory
{
	/**
	* Returns the applicable painter to paint the element.
	*/
	Painter getPainter();
}
