package vp.visual.paint;

import vp.graph.PathwayElement;
import vp.graph.PathwayVertex;
import java.awt.Graphics2D;

/**
* An interface for the painting of visual vertices and decorations.  It is implemented by 
* <code>VisualVertexPainterImp</code>.
*
* @see edu.yale.graph.visual.painting.VisualVertexPainterImp
*/
public interface VertexPainter extends Painter
{
	/**
	* Paint the border of the element.
	*/
	void paintOutline(PathwayVertex element, Graphics2D g2);

	/**
	* Paint the body of the element.
	*/
	void paintFill(PathwayVertex element, Graphics2D g2);

	/**
	* Paint the element's label.
	*/
	void paintLabel(PathwayVertex element, Graphics2D g2);

	/**
	* Rescale the element to fit the contents of its label.
	*/
	void rescale(PathwayElement element);
}
