package vp.visual.paint;

/**
* A singleton class that assigns the painter for visual decorations.  Currently this is handled by the <code>
* VisualVertexPainterImp</code> class.
*
* @see edu.yale.graph.visual.painting.VisualVertexPainterImp
*/
public final class VertexPainterFactoryImp
	extends VertexPainterFactory
{
	private static VertexPainterFactoryImp instance;
	private VertexPainter painter;

	private VertexPainterFactoryImp()
	{}

	/**
	* Returns the single instance of this class.
	*/
	public static VertexPainterFactoryImp getInstance()
	{
		if (instance == null)
			instance = new VertexPainterFactoryImp();
		return instance;
	}

	/**
	* Returns the painter to be used for this element.
	*/
	public Painter getPainter()
	{
		if (painter == null)
			painter = new VertexPainterImp();
		return painter;
	}
}
