package vp.visual.type;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.Ellipse2D;
import java.awt.geom.GeneralPath;

/**
* A default decoration type, generally used to represent enzymes.
*/
public class DefaultDecorationType1 extends Type
{
	/**
	* Creates a type using the default values.		<br><br>
	* Outline color:	black(0, 0, 0)				<br>
	* Fill color:		green(0, 213, 0)			<br>
	* Font color:		red(255, 0, 0)				<br>
	* Font:				Dialog 10-pt				<br>
	* Draw path:		Ellipse (5, 5, 10, 10)		<br>
	* Shape:			"Ellipse"					<br>
	* Name:				"Default Decoration Type 1"	<br>
	* Short name:		"Type1"						<br>
	*/
	public DefaultDecorationType1()
	{
		outlineColor = Color.black;
		fillColor = new Color(0, 213, 0);
		fontColor = Color.red;
		font = new Font("Dialog", Font.PLAIN, 10);
		drawPath = new GeneralPath(new Ellipse2D.Float(5, 5, 10, 10));
		shape = "Ellipse";
		name = "Default Decoration Type 1";
		shortName = "Type1";
	}
}
