package vp.visual.type;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;

/**
* A default vertex type, generally used to represent compounds.
*/
public class DefaultVertexType1 extends Type
{
	/**
	* Creates a type using the default values.		<br><br>
	* Outline color:	black(0, 0, 0)				<br>
	* Fill color:		aqua(135, 206, 250)			<br>
	* Font color:		black(0, 0, 0)				<br>
	* Font:				PalatinoLinotype 10-pt		<br>
	* Draw path:		Rectangle (5, 5, 10, 10)	<br>
	* Shape:			"Rectangle"					<br>
	* Name:				"Default Vertex Type 1"		<br>
	* Short name:		"Type1"						<br>
	*/
	public DefaultVertexType1()
	{
		outlineColor = Color.black;
		fillColor = new Color(0x87CEFA);
		fontColor = Color.black;
		font = new Font("Palatino Linotype", Font.PLAIN, 10);
		drawPath = new GeneralPath(new Rectangle2D.Float(5, 5, 10, 10));
		shape = "Rectangle";
		name = "Default Vertex Type 1";
		shortName = "Type1";
	}
}
