package vp.visual.type;

import java.awt.Color;
import java.awt.Font;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;

/**
* A default vertex type, generally used to represent outside pathways.
*/
public class DefaultVertexType2 extends Type
{
	/**
	* Creates a type using the default values.		<br><br>
	* Outline color:	black(0, 0, 0)				<br>
	* Fill color:		pink(255, 193, 193)			<br>
	* Font color:		black(0, 0, 0)				<br>
	* Font:				PalatinoLinotype 10-pt Ital	<br>
	* Draw path:		Rectangle (5, 5, 10, 10)	<br>
	* Shape:			"Rectangle"					<br>
	* Name:				"Default Vertex Type 2"		<br>
	* Short name:		"Type2"						<br>
	*/
	public DefaultVertexType2()
	{
		outlineColor = Color.black;
		fillColor = new Color(255, 193, 193);
		fontColor = Color.black;
		font = new Font("Palatino Linotype", Font.ITALIC, 10);
		drawPath = new GeneralPath(new Rectangle2D.Float(5, 5, 10, 10));
		shape = "Rectangle";
		name = "Default Vertex Type 2";
		shortName = "Type2";
	}
}
