package vp.visual.type;

import java.awt.Font;
import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;

import vp.gui.VPSettings;

/**
* The default vertex type used by <code>DummyVertex</code>.
*
* @see edu.yale.graph.DummyVertex
*/
public class InvisibleVertex extends Type
{
	/**
	* Creates a type using the default values.		<br><br>
	* Outline color:	invisible(255, 255, 255, 0)	<br>
	* Fill color:		invisible(255, 255, 255, 0)	<br>
	* Font color:		invisible(255, 255, 255, 0)	<br>
	* Font:				PalatinoLinotype 10-pt		<br>
	* Draw path:		Rectangle (5, 5, 10, 10)	<br>
	* Shape:			"Rectangle"					<br>
	* Name:				"Invisible Vertex"			<br>
	*/
	public InvisibleVertex()
	{
		outlineColor = VPSettings.Colors.CLEAR;
		fillColor = VPSettings.Colors.CLEAR;
		fontColor = VPSettings.Colors.CLEAR;
		font = new Font("Palatino Linotype", Font.PLAIN, 10);
		drawPath = new GeneralPath(new Rectangle2D.Float(0, 0, 1, 1));
		//drawPath = new GeneralPath(new Rectangle2D.Float(5, 5, 10, 10));
		shape = "Rectangle";
		name = "Invisible Vertex";
	}
}
